; SYSTBLE.ASM
; PROGETTO: B1601
; Compilatore Avocet X65816

; vettori sys funcs

_SYSTBLE_	.SET	1

	.INCLUDE inc\global.inc

;----------------------------------------------------------
; MACRO FILL COP VECTORS
;----------------------------------------------------------
	
SETVCOP	.MACRO	xcnt
vcnt:	.VAR	xcnt
	.IF	(vcnt = 256)
	.IFCLEAR
	.MACEXIT
	.ENDIF
	.IFDEF	VCOP_|<xcnt>
	.IFNDEF	HCOP_|<xcnt>
	.EXIT	"ERROR: <HCOP_XXX> not defined."
	.ENDIF
vb1:	.VAR	VCOP_|<xcnt>
vb2:	.VAR	HCOP_|<xcnt>
	.MLIST
	.DB	<vb1, >vb1, ^vb1, <vb2
	.MNLIST
	.ELSE
	.MLIST
	.DB	0, 0, 0, $FF
	.MNLIST
	.ENDIF
vcnt:	.VAR	vcnt + 1
	SETVCOP	vcnt
	.ENDM

DEFSYS	.MACRO	xcnt, num, name
	.IFNDEF	name
	.EXTERN	name
	.ENDIF
	.MLIST
vec	.VAR	xcnt
VCOP_|<vec>	.EQU	name
HCOP_|<vec>	.EQU	num
	.MNLIST
	.ENDM


;----------------------------------------------------------
; DEFINE SYSTEM FUNCTIONS
;----------------------------------------------------------


	DEFSYS		FN_TASKSW, $00, sys_tasksw			; $00		
	DEFSYS		$01, $00, COP_ScnPrint
	DEFSYS		$02, $00, COP_TxtPrint
	DEFSYS		$03, $00, COP_ScnStrOut
	DEFSYS		$04, $00, COP_TxtStrOut	
	DEFSYS		$05, $00, COP_ScnCharOut
	DEFSYS		$06, $00, COP_TxtCharOut
	DEFSYS		$07, $00, COP_ScnPrChar	
	DEFSYS		$08, $00, COP_TxtPrChar	
	;;DEFSYS		$09, $00, COP_ScnGetPos
	;;DEFSYS		$0A, $00, COP_ScnSetPos
	DEFSYS		$0B, $00, COP_ScnPasStr
	DEFSYS		$0C, $00, COP_TxtPasStr
	DEFSYS		$0D, $00, COP_ScnBufOut
	DEFSYS		$0E, $00, COP_TxtBufOut
	DEFSYS		$0F, $00, COP_KbCharIn
	DEFSYS		$10, $00, COP_TxtCharIn
	DEFSYS		$11, $00, sys_bprintf
	DEFSYS		$12, $00, sys_bsprintf
	DEFSYS		$13, $00, sys_bvprintf
	DEFSYS		$14, $00, sys_bsprintf2
	DEFSYS		$15, $00, COP_DevCharOut
	DEFSYS		$16, $00, COP_DevCharIn
	DEFSYS		$17, $00, COP_KeybGet
	DEFSYS		$18, $00, COP_ScnCtl

	DEFSYS		$19, $00, sys_rtc

	DEFSYS		$30, $00, sys_fdctl
	DEFSYS		$31, $07, sys_fdrw
	DEFSYS		$33, $06, sys_fdfmt
	DEFSYS		$34, $04, sys_fdverf
	DEFSYS		$35, $04, sys_fdtrack
	DEFSYS		$36, $07, sys_mkfs
	
	DEFSYS		$40, $09, sys_atarw
	DEFSYS		$41, $00, sys_atactl
	
	DEFSYS		$60, $03, tos_cmd

	DEFSYS		$FE, $07, COP_truenam
	DEFSYS		$FF, $00, COP_ScnXchg
	
	DEFSYS		FN_SETBRK,	$00, COP_setbrk			; $7F

	DEFSYS		FN_CBMFSCMD,	$04, COP_cbmfs_cmd		; $80
	DEFSYS		FN_CBMFSRW,	$06, COP_cbmfs_rw		; $81
	DEFSYS		FN_CBMFSCLS,	$00, COP_cbmfs_close		; $82
	.SYSTBLE
	
	SETVCOP		0
	