;;
;; Copyright (c) 2016 Marco Granati <mg@unet.bz>
;;
;; Permission to use, copy, modify, and distribute this software for any
;; purpose with or without fee is hereby granted, provided that the above
;; copyright notice and this permission notice appear in all copies.
;;
;; THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
;; WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
;; MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
;; ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
;; WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
;; ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
;; OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
;;

;; name: slib.asm	
;; rev.: 2016/22/10
;; o.s. 65C816 version v1.0

;; shared library 

	.INCLUDE inc\global.inc

.LIST on

;---------------------------------------------------------------------------
; code segment -- bank $FA (start)
;---------------------------------------------------------------------------

	.SLIBFA
	.EXTERN _getopt, _strlen, _strcpy

	.LONGA	off
	.LONGI	off

;---------------------------------------------------------------------------
; library interface -- static jump table
;---------------------------------------------------------------------------

; getopt	$FA0000		getopt.asm
	jmp	_getopt

; strlen	$FA0003		string.asm
	jmp	_strlen

; strcpy	$FA0006		string.asm
	jmp	_strcpy
