
	.INCLUDE inc\global.inc

	.CODEFE
	.LONGA off
	.LONGI off

	GLOBAL	PCTYPEREC, PCSFADDR, PCTORSIZ, PCRSWD, PCROFS
 	GLOBAL  PCCOMP, PCCDST
 	;GLOBAL PCCOMPSIZ, PCTORAM
 
; compiled p-code for running pascal compiler
; original offset at $3000

PCCDST		.EQU	$3000

PCCOMP:
	; compiler p-code
	.INCLUDE inc\pcc.inc

PCCOMPSIZ	.EQU	($ - PCCOMP)

; offset of ram address used by compiler	
;PCROFS	.EQU	$216E
;PCROFS	.EQU	$0010

PCROFS	.EQU	PCCOMPSIZ

PCTORAM:
; record (size = 12 bytes) that encode basic standard 'type'
	.DW	$7FFF, $8000, $0000, $0000, $0000, $0001	; integer 
TYIPTR	.EQU	(12 + PCROFS)	; ptr record 'integer;
	.DW	$007F, $0000, $0000, $0000, $0000, $0001	; char 
TYCPTR	.EQU	(24 + PCROFS)	; ptr record 'char'
	.DW	$0001, $0000, $0000, $0000, $0000, $0001	; boolean 
TYBPTR	.EQU	(36 + PCROFS)	; ptr record 'boolean'
	.DW	$0000, $0000, $0003, $0000, $0000, $0003	; real
TYRPTR	.EQU	(48 + PCROFS)	; ptr record 'real'
	.DW	$0000, $0000, $0005, TYCPTR, $0000, $0003	; text 
TYTPTR	.EQU	(60 + PCROFS)	; ptr record 'text'

;	.DW	$0080, $0001, $0001, TYIPTR, $000C, $0001	; packed array [1..128] 
;TYA128	.EQU	(72 + PCROFS)
;	.DW	$0001, TYA128, $0002, TYCPTR, $0010, $0040	; packed array [1..128] of char 
;TYPKC128	.EQU	(84 + PCROFS)
;	;.DW	$0000, TYPKC128, $0006, $0000, $0000, $0001	; packed array [1..128] of char 
;PKCPTR	.EQU	(96 + PCROFS)

PCROFS1	.EQU	($ - PCTORAM + PCROFS)

X:	.SET	PCROFS1

; table of pre-defined standard procedures & functions
	.DW	$0005
	.DB	'ORD     '
	.DW	$0000,	$0000,	$0000
	.DW	(18 + $12 + X)
	X:	.SET	(X + 18)
	
PCSFADDR	.EQU	X

	.DW	$0005
	.DB	'PRED    '
	.DW	$0000,	$0001,	$0000
	.DW	(18 + $12 + X)
	X:	.SET	(X + 18)
	.DW	$0005
	.DB	'SUCC    '
	.DW	$0000,	$0002,	$0000
	.DW	(18 + $12 + X)
	X:	.SET	(X + 18)
	.DW	$0005
	.DB	'SQR     '
	.DW	$0000,	$0003,	$0000
	.DW	(18 + $12 + X)
	X:	.SET	(X + 18)
	.DW	$0005
	.DB	'ABS     '
	.DW	$0000,	$0004,	$0000
	.DW	(18 + $12 + X)
	X:	.SET	(X + 18)
	.DW	$0005
	.DB	'EOLN    '
	.DW	$0000,	$0005,	$0000
	.DW	(18 + $12 + X)
	X:	.SET	(X + 18)
	.DW	$0005
	.DB	'EOF     '
	.DW	$0000,	$0006,	$0000
	.DW	(20 + $12 + X)
	X:	.SET	(X + 18)
;------------------------------------------------------
	.DW	TY1I,	$0002
	.DB	'CHR     '
	.DW	TYCPTR,	$0005,	$FFFE
	.DW	(20 + $14 + X)
	X:	.SET	(X + 20)
	.DW	TY1C,	$0002
	.DB	'ASC     '
	.DW	TYIPTR,	$0005,	$FFFE
	.DW	(20 + $14 + X)
	X:	.SET	(X + 20)
	.DW	TY1I,	$0002
	.DB	'ODD     '
	.DW	TYBPTR,	$0004,	$FFFE
	.DW	(20 + $14 + X)
	X:	.SET	(X + 20)
	.DW	TY2I,	$0002
	.DB	'SHR     '
	.DW	TYIPTR,	$002C,	$FFFE
	.DW	(20 + $14 + X)
	X:	.SET	(X + 20)
	.DW	TY2I,	$0002
	.DB	'SHL     '
	.DW	TYIPTR,	$002B,	$FFFE
	.DW	(20 + $14 + X)
	X:	.SET	(X + 20)
	.DW	TY2I,	$0002
	.DB	'ORW     '
	.DW	TYIPTR,	$001C,	$FFFE
	.DW	(20 + $14 + X)
	X:	.SET	(X + 20)
	.DW	TY2I,	$0002
	.DB	'XORW    '
	.DW	TYIPTR,	$001D,	$FFFE
	.DW	(20 + $14 + X)
	X:	.SET	(X + 20)
	.DW	TY2I,	$0002
	.DB	'ANDW    '
	.DW	TYIPTR,	$001B,	$FFFE
	.DW	(20 + $14 + X)
	X:	.SET	(X + 20)
	.DW	TY1I,	$0002
	.DB	'NOTW    '
	.DW	TYIPTR,	$001E,	$FFFE
	.DW	(20 + $14 + X)
	X:	.SET	(X + 20)
	.DW	TY1I,	$0002
	.DB	'NEGW    '
	.DW	TYIPTR,	$001F,	$FFFE
	.DW	(20 + $14 + X)
	X:	.SET	(X + 20)
	.DW	$0000,	$0002
	.DB	'IOERROR '
	.DW	TYIPTR,	$0018,	$FFFE
	.DW	(20 + $14 + X)
	X:	.SET	(X + 20)	
	.DW	TY1R,	$0002
	.DB	'TRUNC   '
	.DW	TYIPTR,	$0013,	$FFFE
	.DW	(20 + $14 + X)
	X:	.SET	(X + 20)
	.DW	TY1R,	$0002
	.DB	'ROUND   '
	.DW	TYIPTR,	$0014,	$FFFE
	.DW	(20 + $14 + X)
	X:	.SET	(X + 20)
	.DW	TY1R,	$0002
	.DB	'SIN     '
	.DW	TYRPTR,	$0008,	$FFFE
	.DW	(20 + $14 + X)
	X:	.SET	(X + 20)
	.DW	TY1R,	$0002
	.DB	'COS     '
	.DW	TYRPTR,	$0009,	$FFFE
	.DW	(20 + $14 + X)
	X:	.SET	(X + 20)
	.DW	TY1R,	$0002
	.DB	'TAN     '
	.DW	TYRPTR,	$000A,	$FFFE
	.DW	(20 + $14 + X)
	X:	.SET	(X + 20)	
	.DW	TY1R,	$0002
	.DB	'EXP     '
	.DW	TYRPTR,	$000C,	$FFFE
	.DW	(20 + $14 + X)
	X:	.SET	(X + 20)	
	.DW	TY1R,	$0002
	.DB	'EXP10   '
	.DW	TYRPTR,	$002D,	$FFFE
	.DW	(20 + $14 + X)
	X:	.SET	(X + 20)
	.DW	TY1R,	$0002
	.DB	'LN      '
	.DW	TYRPTR,	$000D,	$FFFE
	.DW	(20 + $14 + X)
	X:	.SET	(X + 20)
	.DW	TY1R,	$0002
	.DB	'LOG     '
	.DW	TYRPTR,	$002E,	$FFFE
	.DW	(20 + $14 + X)
	X:	.SET	(X + 20)
	.DW	TY1R,	$0002
	.DB	'SQRT    '
	.DW	TYRPTR,	$000E,	$FFFE
	.DW	(20 + $14 + X)
	X:	.SET	(X + 20)
	.DW	TY1R,	$0002
	.DB	'ARCTAN  '
	.DW	TYRPTR,	$000B,	$FFFE
	.DW	(20 + $14 + X)
	X:	.SET	(X + 20)
	.DW	TY2R,	$0002
	.DB	'RAISEXY '
	.DW	TYRPTR,	$000F,	$FFFE
	.DW	(20 + $14 + X)	
	X:	.SET	(X + 20)
	.DW	TY1R1I,	$0002
	.DB	'NRAISE  '
	.DW	TYRPTR,	$002F,	$FFFE
	.DW	(20 + $14 + X)	
	X:	.SET	(X + 20)
	.DW	TY1R1I,	$0002
	.DB	'NROOT   '
	.DW	TYRPTR,	$0010,	$FFFE
	.DW	(20 + $14 + X)	
	X:	.SET	(X + 20)	
	.DW	$0000,	$0002
	.DB	'RANDOM  '
	.DW	TYIPTR,	$0015,	$FFFE
	.DW	(20 + $14 + X)
	X:	.SET	(X + 20)
	.DW	$0000,	$0002
	.DB	'GETKEY  '
	.DW	TYCPTR,	$0019,	$FFFE
	.DW	(20 + $14 + X)
	X:	.SET	(X + 20)
	.DW	TY1T,	$0002
	.DB	'FRDHEX  '
	.DW	TYIPTR,	$001A,	$FFFE
	.DW	(20 + $14 + X)
	X:	.SET	(X + 20)
	.DW	$0000,	$0002
	.DB	'RDHEX   '
	.DW	TYIPTR,	$0020,	$FFFE
	.DW	(20 + $14 + X)
	X:	.SET	(X + 20)
	.DW	TY1I,	$0002
	.DB	'PEEKB   '
	.DW	TYIPTR,	$0000,	$FFFE
	.DW	(20 + $14 + X)
	X:	.SET	(X + 20)
	.DW	TY2I,	$0002
	.DB	'LPEEKB  '
	.DW	TYIPTR,	$0023,	$FFFE
	.DW	(20 + $14 + X)
	X:	.SET	(X + 20)
	.DW	TY2I,	$0002
	.DB	'LPEEKW  '
	.DW	TYIPTR,	$0024,	$FFFE
	.DW	(20 + $14 + X)
	X:	.SET	(X + 20)
	.DW	TY1I,	$0002
	.DB	'PEEKBZ  '
	.DW	TYIPTR,	$0002,	$FFFE
	.DW	(20 + $14 + X)
	X:	.SET	(X + 20)
	.DW	TY1I,	$0002
	.DB	'PEEKW   '
	.DW	TYIPTR,	$0001,	$FFFE
	.DW	(20 + $14 + X)
	X:	.SET	(X + 20)
	.DW	TY1P,	$0002
	.DB	'ORDP    '
	.DW	TYIPTR,	$0001,	$FFFE
	.DW	(20 + $14 + X)
	X:	.SET	(X + 20)
	.DW	TY1I,	$0002
	.DB	'PEEKWZ  '
	.DW	TYIPTR,	$0003,	$FFFE
	.DW	(18 + $14 + X)
	X:	.SET	(X + 20)

;------------------------------------------------------
	.DW	$0004
	.DB	'WRITE   '
	.DW	$0000,	$0000,	$0000
	.DW	(18 + $12 + X)
	X:	.SET	(X + 18)
	.DW	$0004
	.DB	'WRITELN '
	.DW	$0000,	$0001,	$0000
	.DW	(18 + $12 + X)
	X:	.SET	(X + 18)
	.DW	$0004
	.DB	'READ    '
	.DW	$0000,	$0002,	$0000
	.DW	(18 + $12 + X)
	X:	.SET	(X + 18)
	.DW	$0004
	.DB	'READLN  '
	.DW	$0000,	$0003,	$0000
	.DW	(18 + $12 + X)
	X:	.SET	(X + 18)
	.DW	$0004
	.DB	'NEW     '
	.DW	$0000,	$0004,	$0000
	.DW	(18 + $12 + X)
	X:	.SET	(X + 18)
	.DW	$0004
	.DB	'PAGE    '
	.DW	$0000,	$0005,	$0000
	.DW	(18 + $12 + X)
	X:	.SET	(X + 18)
	.DW	$0004
	.DB	'PUT     '
	.DW	$0000,	$0006,	$0000
	.DW	(18 + $12 + X)
	X:	.SET	(X + 18)
	.DW	$0004
	.DB	'GET     '
	.DW	$0000,	$0007,	$0000
	.DW	(18 + $12 + X)
	X:	.SET	(X + 18)
	.DW	$0004
	.DB	'RESET   '
	.DW	$0000,	$0008,	$0000
	.DW	(18 + $12 + X)
	X:	.SET	(X + 18)
	.DW	$0004
	.DB	'REWRITE '
	.DW	$0000,	$0009,	$0000
	.DW	(18 + $12 + X)
	X:	.SET	(X + 18)
	.DW	$0004
	.DB	'DISPOSE '
	.DW	$0000,	$000A,	$0000
	.DW	(18 + $12 + X)
	X:	.SET	(X + 18)
	.DW	$0004
	.DB	'PACK    '
	.DW	$0000,	$000B,	$0000
	.DW	(18 + $12 + X)
	X:	.SET	(X + 18)
	.DW	$0004
	.DB	'UNPACK  '
	.DW	$0000,	$000C,	$0000
	.DW	(18 + $12 + X)
	X:	.SET	(X + 18)
	.DW	$0004
	.DB	'CHAIN   '
	.DW	$0000,	$0011,	$0000
	.DW	(18 + $12 + X)
	X:	.SET	(X + 18)
	.DW	$0004
	.DB	'CLOSE   '
	.DW	$0000,	$0012,	$0000
	.DW	(20 + $12 + X)
	X:	.SET	(X + 18)
;------------------------------------------------------
	.DW	TY1P1I,	$0002
	.DB	'PASSIGN '
	.DW	$0000,	$0012,	$FFFE
	.DW	(20 + $14 + X)
	X:	.SET	(X + 20)
	.DW	TY1P, $0002
	.DB	'PCMDLINE'
	.DW	$0000,	$0030,	$FFFE
	.DW	(20 + $14 + X)
	X:	.SET	(X + 20)
	.DW	TY1T1I,	$0002
	.DB	'FWRHEXW '
	.DW	$0000,	$0006,	$FFFE
	.DW	(20 + $14 + X)
	X:	.SET	(X + 20)
	.DW	TY1I,	$0002
	.DB	'WRHEXW  '
	.DW	$0000,	$0021,	$FFFE
	.DW	(20 + $14 + X)
	X:	.SET	(X + 20)
	.DW	TY1P,	$0002
	.DB	'WRHEXP  '
	.DW	$0000,	$0021,	$FFFE
	.DW	(20 + $14 + X)
	X:	.SET	(X + 20)
	.DW	TY1T1I,	$0002
	.DB	'FWRHEXB '
	.DW	$0000,	$0007,	$FFFE
	.DW	(20 + $14 + X)
	X:	.SET	(X + 20)
	.DW	TY1I,	$0002
	.DB	'WRHEXB  '
	.DW	$0000,	$0022,	$FFFE
	.DW	(20 + $14 + X)
	X:	.SET	(X + 20)
	.DW	TY1B,	$0002
	.DB	'IOTRAP  '
	.DW	$0000,	$0016,	$FFFE
	.DW	(20 + $14 + X)
	X:	.SET	(X + 20)
	.DW	TY1B,	$0002
	.DB	'BREAKS  '
	.DW	$0000,	$0017,	$FFFE
	.DW	(20 + $14 + X)
	X:	.SET	(X + 20)
	.DW	TY2I,	$0002
	.DB	'POKEB   '
	.DW	$0000,	$0025,	$FFFE
	.DW	(20 + $14 + X)
	X:	.SET	(X + 20)
	.DW	TY2I,	$0002
	.DB	'POKEW   '
	.DW	$0000,	$0026,	$FFFE
	.DW	(20 + $14 + X)
	X:	.SET	(X + 20)
	.DW	TY2I,	$0002
	.DB	'POKEBZ  '
	.DW	$0000,	$0027,	$FFFE
	.DW	(20 + $14 + X)
	X:	.SET	(X + 20)
	.DW	TY2I,	$0002
	.DB	'POKEWZ  '
	.DW	$0000,	$0028,	$FFFE
	.DW	(20 + $14 + X)
	X:	.SET	(X + 20)
	.DW	TY3I,	$0002
	.DB	'LPOKEB  '
	.DW	$0000,	$0029,	$FFFE
	.DW	(20 + $14 + X)
	X:	.SET	(X + 20)
	.DW	TY3I,	$0002
	.DB	'LPOKEW  '
	.DW	$0000,	$002A,	$FFFE
	.DW	(18 + $14 + X)
	X:	.SET	(X + 20)
;------------------------------------------------------
; record 18 bytes
	.DW	$0003
	.DB	'INTEGER '
	.DW	TYIPTR,	$0000,	$0000
	.DW	(18 + $12 + X)
	X:	.SET	(X + 18)
	.DW	$0003
	.DB	'BOOLEAN '
	.DW	TYBPTR,	$0000,	$0000
	.DW	(18 + $12 + X)
	X:	.SET	(X + 18)
	.DW	$0003
	.DB	'CHAR    '
	.DW	TYCPTR,	$0000,	$0000
	.DW	(18 + $12 + X)
	X:	.SET	(X + 18)
	.DW	$0003
	.DB	'REAL    '
	.DW	TYRPTR,	$0000,	$0000
	.DW	(18 + $12 + X)
	X:	.SET	(X + 18)
	.DW	$0003
	.DB	'TEXT    '
	.DW	TYTPTR,	$0000,	$0000
	.DW	(18 + $12 + X)
	X:	.SET	(X + 18)
	.DW	$0001
	.DB	'TRUE    '
	.DW	TYBPTR,	$0001,	$0000
	.DW	(18 + $12 + X)
	X:	.SET	(X + 18)
	.DW	$0001
	.DB	'FALSE   '
	.DW	TYBPTR,	$0000,	$0000
	.DW	(18 + $12 + X)
	X:	.SET	(X + 18)
	.DW	$0001
	.DB	'MAXINT  '
	.DW	TYIPTR,	$7FFF,	$0000
	.DW	(20 + $12 + X)
	X:	.SET	(X + 18)
;------------------------------------------------------
; record 20 bytes
	.DW	$0000,	$0000
	.DB	'INPUT   '
	.DW	TYTPTR,	$0000,	$0000
	.DW	(20 + $14 + X)
	X:	.SET	(X + 20)
	.DW	$0000,	$0000
	.DB	'OUTPUT  '
	.DW	TYTPTR,	$0001,	$0000
	;.DW	$0000
	.DW	(24 + $14 + X)
	;X:	.SET	(X + 20)
	X:	.SET	(X + 22)
	.DW	$0000,$DA0F, $00A2, $0001
	.DB	'PI      '
	.DW	TYRPTR,	$4982,	$0000
	;.DW	(20 + $14 + X)		; last pointer = NULL
	.DW	$0000
	X:	.SET	(X + 22)
	
PCROFS2	.EQU	X

; record (size = 6 bytes) that encode basic standard parametr's list
	.DW	TYIPTR,	$0000,	$0000
TY1I	.EQU	((1*6) + PCROFS2)	; 1 integer
	.DW	TYIPTR,	$0000,	TY1I 
TY2I	.EQU	((2*6) + PCROFS2)	; 2 integer
	.DW	TYTPTR,	$0000,	$0000 
TY1T	.EQU	((3*6) + PCROFS2)	; 1 text
	.DW	TYTPTR,	$0000,	TY1I 
TY1T1I	.EQU	((4*6) + PCROFS2)	; 1 text, 1 integer
	.DW	TYBPTR,	$0000,	$0000 
TY1B	.EQU	((5*6) + PCROFS2)	; 1 boolean
	.DW	TYRPTR,	$0000,	$0000 
TY1R	.EQU	((6*6) + PCROFS2)	; 1 real
	.DW	$0000,	$0001,	TY1I 
TY1P1I	.EQU	((7*6) + PCROFS2)	; 1 var pointer, 1 integer
	.DW	TYCPTR,	$0000,	$0000 
TY1C	.EQU	((8*6) + PCROFS2)	; 1 char
	.DW	TYIPTR,	$0000,	TY1C
TY1I1C	.EQU	((9*6) + PCROFS2)	; 1 integer, 1 char
	.DW	TYIPTR,	$0000,	TY1I1C
TY2I1C	.EQU	((10*6) + PCROFS2)	; 2 integer, 1 char
	.DW	TYIPTR,	$0000,	TY2I
TY3I	.EQU	((11*6) + PCROFS2)	; 3 integer
	.DW	TYIPTR,	$0000,	TY3I
TY4I	.EQU	((12*6) + PCROFS2)	; 4 integer
	.DW	TYRPTR,	$0000,	TY1R 
TY2R	.EQU	((13*6) + PCROFS2)	; 2 real
	.DW	TYRPTR,	$0000,	TY1I 
TY1R1I	.EQU	((14*6) + PCROFS2)	; 1 real, 1 integer
	.DW	$0000,	$0001, $0000
TY1P	.EQU	((15*6) + PCROFS2)	; 1 var pointer
;	.DW	$0000, $0001, TY1P
;TY2P	.EQU	((16*6) + PCROFS2)	; 2 var pointer


;PCTORSIZ	.EQU	($ - PCTORAM)
PCTORSIZ	.EQU	($ - PCCOMP)

PCRSWD:
  .DB	'AND ARRAY BEGIN CASE CONST DIV DO DOWNTO ELSE END EXTERN FILE FOR '
  .DB   'FORWARD FUNCTION GOTO IF IN LABEL MOD NIL NOT OF OR PACKED PROCEDUR '
  .DB   'PROGRAM RECORD REPEAT THEN TO TYPE UNTIL VAR WITH WHILE SET ',0
 	
; pointer to basic standard type - copied to stack by compiler
PCTYPEREC:
	.DW	TYTPTR, TYRPTR, TYBPTR, TYCPTR, TYIPTR, $0001, $0001, $0000
	.DW	$0000, $0000

;>275E 7A 21 00 00 00 00	2764 1 integer
;>2764 7A 21 00 00 64 27	276A 2 integer
;>276A AA 21 00 00 00 00	2770 1 text
;>2770 AA 21 00 00 64 27	2776 1 text 1 integer
;>2776 92 21 00 00 00 00	277C 1 boolean
;>277C 9E 21 00 00 00 00	2782 1 real
;>2782 00 00 01 00 64 27	2788 1 integer byte ORIGIN(pointer, address)
;>2788 86 21 00 00 00 00	278E 1 char
;>278E 7A 21 00 00 8E 27	2794 1 integer 1 char
;>2794 7A 21 00 00 94 27	279A 2 integer 1 char VDU(row,col, char)
;>279A 7A 21 00 00 6A 27	27A0 3 integer
;>27A0 7A 21 00 00 A0 27	27A6 4 integer
;>27A6 7A 21 00 00 A6 27	27AC 5 integer 
;>27AC
