;----------------------------------------------------------
; SCN.INC
; PROGETTO: B1601
;
; costanti per funzioni out screen
;----------------------------------------------------------

; il file puo' essere incluso solo all'interno di GLOBAL.INC
.IFNDEF		_GLOBAL_INC_
.EXIT		"ERROR: This file cannot be included."
.ENDIF

.IFDEF	_SCN_INC_

; codici di controllo
SCN_CSRUP	.EQU	$01	; CURSOR UP
SCN_CSRRIGHT	.EQU	$02	; CURSOR RIGHT
SCN_CSRDOWN	.EQU	$03	; CURSOR DOWN
SCN_CSRLEFT	.EQU	$04	; CURSOR LEFT
SCN_HOME	.EQU	$05	; CURSOR HOME
SCN_END		.EQU	$06	; END
SCN_BELL	.EQU	$07	; BELL
SCN_BS		.EQU	$08	; BACKSPACE
SCN_TAB		.EQU	$09	; TAB
SCN_LF		.EQU	$0A	; LINE FEED
SCN_SHTAB	.EQU	$0B	; SHIFT + TAB
SCN_CLR		.EQU	$0C	; SCREEN CLEAR
SCN_CR		.EQU	$0D	; CARRIAGE RETURN
SCN_INSERT	.EQU	$0E	; INSERT
SCN_DELETE	.EQU	$0F	; DELETE
SCN_SHCR	.EQU	$10	; SHIFT + ENTER
SCN_PGUP	.EQU	$11	; PAGE UP
SCN_PGDOWN	.EQU	$12	; PAGE DOWN
SCN_ALTFNT	.EQU	$13	; ALTERNATE FONT
SCN_RVSON	.EQU	$14	; REVERSE ON
SCN_ULON	.EQU	$15	; UNDERLINE ON
SCN_BLINKON	.EQU	$16	; BLINK ON
SCN_DEFFNT	.EQU	$17	; DEFAULT FONT
SCN_RVSOFF	.EQU	$18	; REVERSE OFF
SCN_ULOFF	.EQU	$19	; UNDERLINE OFF
SCN_BLINKOFF	.EQU	$1A	; BLINK OFF
SCN_ESC		.EQU	$1B	; SCREEN ESCAPE SEQUENCE
SCN_COL		.EQU	$1C	; FOREGROUND COLOR
SCN_BKGCOL	.EQU	$1D	; BACKGROUND COLOR
SCN_PRTSCN	.EQU	$1E	; PRINT SCRN CODE
SCN_PASS	.EQU	$1F	; PASS CODE CHAR $00..$1F

; codici colore
SCN_BLACK	.EQU	$01	; BLACK
SCN_DARKGRAY	.EQU	$02	; DARK GRAY
SCN_DARKBLUE	.EQU	$03	; DARK BLUE
SCN_BLUE	.EQU	$04	; LIGHT BLUE
SCN_DARKGREEN	.EQU	$05	; DARK GREEN
SCN_GREEN	.EQU	$06	; LIGHT GREEN
SCN_DARKCYAN	.EQU	$07	; DARK CYAN
SCN_CYAN	.EQU	$08	; LIGHT CYAN
SCN_DARKRED	.EQU	$09	; DARK RED
SCN_RED		.EQU	$0A	; LIGHT RED
SCN_DARKPURPLE	.EQU	$0B	; DARK PURPLE
SCN_PURPLE	.EQU	$0C	; LIGHT PURPLE
SCN_BROWN	.EQU	$0D	; BROWN / DARK YELLOW
SCN_YELLOW	.EQU	$0E	; LIGHT YELLOW
SCN_LIGHTGRAY	.EQU	$0F	; LIGHT GRAY
SCN_WHITE	.EQU	$10	; WHITE
SCN_DEFCOLOR	.EQU	$11	; DEFAULT COLOR

.ENDIF
