
.LIST on
; page 0 (LDT var's) local var's 
_FSTMP:	.SECTION page0, ref_only, offset bpath
FSTMP_START	.EQU	$

maxsec		.LWORD		; ata device max sector's
hidsec		.LWORD		; hidden sectors
totsec		.LWORD		; partition size in sector's
maxcnt		.DW		; max. cluster's count
first		.DW		; relative first data sector

totrsv		.EQU	first
bcbbnk		.EQU	maxsec
hcbsiz		.EQU	maxsec+2
hcbrem		.EQU	maxcnt
tbdrv		.EQU	maxsec
tbcls		.EQU	maxsec+2
tblba		.EQU	hidsec
tbhead		.EQU	hidsec+2
tbtrk		.EQU	totsec
tbptr		.EQU	totsec+2
tbdma		.EQU	maxcnt
fdopt		.EQU	maxsec
fdarg		.EQU	maxsec+1
fdlbl		.EQU	maxsec+2

clscnt		.DW		; cluster's count #
rsvsec		.DW		; reserved sector's
fatsiz		.DW		; FAT16 fat table size
rootsiz		.DW		; root directory size
rootent		.DW		; root dir. max. entries
clsent		.DW		; sub-diectory max. entries
root		.DW		; root dir start
fat1		.DW		; fat1 table start
fat2		.DW		; fat 2 table start
start		.DW		; first data sector
maxcls		.DW		; last usable cluster+1
xfatb		.DW		; x-mem fat table buffer

fdix		.EQU	xfatb	; floppy disk index DD/HD
media		.EQU	xfatb+1	; floppy disk media field

flba		.DW		; low 16 bit lba
freecnt		.DW		; free cluster's count
freecls		.DW		; first free cluster

remsec		.EQU	freecnt

pbrp		LP		; PBR pointer
clssiz		.DB		; cluster size
clsshf		.DB		; cluster shift
clsmod		.DB
xbnk		.DB		; x-mem bank
lunit		.DB		; unity letter
tp		LP		; fat cache pointer
fdfmt		.DB		; floppy format
pdev		.DB		; phisycal device
ldev		.DB		; logical device
ldtcur		.DB		; current LDT ptr
lflag		.DB		; flag load fat table
rtcsec		.DB		; seconds
rtcmin		.DB		; minutes

badcls		.EQU	rtcsec

rtchour		.DB		; hours
rtcday		.DB		; day of month
rtcmonth	.DB		; month
rtcyear		.DB		; year
ctime		.DW		; compact time
cdate		.DW
tlp		LP
fd2ix		.DB

nulptr		.EQU	fd2ix	; flag null ptr

rootbnk		.DB

getfmt		.EQU	rootbnk	; get format from floppy disk

fatbnk		.DB
clsbnk		.DB
sec100		.DB		; tenths of seconds for ctime (ms stamp)

FSTMP_SIZ	.EQU	($-FSTMP_START)
	.ENDS
.LIST off
