;;
;; Copyright (c) 2016 Marco Granati <mg@unet.bz>
;;
;; Permission to use, copy, modify, and distribute this software for any
;; purpose with or without fee is hereby granted, provided that the above
;; copyright notice and this permission notice appear in all copies.
;;
;; THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
;; WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
;; MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
;; ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
;; WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
;; ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
;; OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
;;

;; name: fatsys.asm	
;; rev.: 2016/22/10
;; o.s. 65C816 version v1.0

;; system fat function's 

	.INCLUDE inc\global.inc
	.INCLUDE inc\dirp00.inc
	;;.INCLUDE inc\sys_fs.inc
	.INCLUDE inc\tossys.inc

.LIST on

;---------------------------------------------------------------------------
; code segment -- bank $F9
;---------------------------------------------------------------------------

	.CODEF9
	.PUBLIC oserror

	.LONGA	off
	.LONGI	off

;---------------------------------------------------------------------------
; error handler
;---------------------------------------------------------------------------

oserror:
	pea	#P0FAT
	pld
	ldx	#0		; set DBR=0
	phx
	plb
	INDEX16
	ldx	ostos		; restore stack pointer
	txs
	INDEX08
	sec			; error flag
	rts
