
; compiler usa 07-1c ptr
; rivedere R3511, R351E, PC5A, PC4A 
; manca P3E (run) - $3240 (CHAIN)
; rivedere in PC49 (run only) se esiste un lda #0 oppure deve essere un ldy #0
; R2B84 (prepara parametri 'open device') e PC3C, PC3D (run only)
; L09C2 - parametri disk (run e compiler), PC3B, PC6C
;; compiler: 0f-1c usati -- 00-0e liberi / 1d--20 liberi
;; da 21 usati compiler/run

;;;; L1656 --- modificato !!!!


MAXVPME		.EQU	$1B	; max. error code + 1

_CBM_INC_	.EQU	1

	.INCLUDE inc\global.inc
	;.INCLUDE inc\dirp01.inc
	.INCLUDE inc\dpcbm.inc

	.CODEFE
	.LONGA off
	.LONGI off

	.GLOBAL vpmerr, pccstart, pcexec, L0FAA
	.EXTERN XBBD4, XBBA2, XBC5B, XBA8C, XBB12, XBA2B, XB853, XB86A
	.EXTERN XBAFE, XBAE2, XBCF3P, XE26B, XE264, XE2B4, XE30E
	.EXTERN XBFED, XBF7B, XBF71, XB9EA, XBC49, XBB0F, XB9BC, XBBC7
	.EXTERN XBBA2T, XB9E0, FCON05, XB867, XBBA2L, FCON10, XBA8CK
	.EXTERN XBBA2K, XLN10, XBC0C, XBA28

	
;---------------------------------------------------------------------------
; p-cpode main system
;---------------------------------------------------------------------------
		
; start compiler
pccstart:
	.EXTERN PCTORSIZ, PCROFS, PCCOMP, PCCDST
	;.EXTERN  PCTORAM, , PCCOMPSIZ

	phb			; save current data bank
	lda	>CRFWEOFF
	tax
	sta	>CRFWEON	; enable write in bank $FE RAM
	lda	cbnk		; the dest. bank
	sta	>?10+1		; store dest bank for mvn istruction
	;sta	>?12+1		; store dest bank for mvn istruction
	sta	>CRFWEOFF,x	; disable writing in bank $FE
	CPU16
	lda	#PCTORSIZ-1	; transfer type/std functio's record's
	ldx	#PCCOMP		; source address
	;ldx	#PCTORAM	; source address
	;ldy	#PCROFS
	ldy	#0		; dest address
	sty	longp
?10:	mvn	#^pccstart, #0

	;lda	#PCCOMPSIZ-1	; transfer compiler p-code
	;ldx	#PCCOMP		; source address
	;ldy	#PCCDST		; dest. address
	;sty	longp
;?12:	mvn	#^pccstart, #0
	tya
	sta	(longp)		; here bank = cbnk
	CPU08
	;ldy	#$01
	;lda	(longp),y	; p-code
	xba			; hi addess
	tax
	inx
	;inx
	;ldy	#>PCCDST
	ldy	#0

	lda	#1
	sta	autolf
	;inc	a
	sta	tmpdsk
	lda	#$04
	sta	defprn
	;lda	#$80
	;sta	pcdsk
	lda	#$40		; compiler flag for runf
	
pccrun:
	jsr	setmem
	;jsr	L0E89		; print CR
	jsr	pcex
	lda	svbnk		; restore v-bank
	sta	vbnk
	bit	runf		; skip if run mode
	bmi	?04
	bit	pcterr		; no link if any compilation error
	bmi	?04
	lda	pcdsk
	bmi	?01		; compile in memory: link
	bit	fpcflag
	bpl	?04		; old style compilation: no link
?01:	jsr	pclink
	lda	#$80
	sta	pcodef
?04:	stz	runf
	stz	pcdsk
	plb
	rts

pcexec:
	phb
	lda	vbnk
	pha
	plb
	sta	longp+2
	stz	longp
	stz	longp+1
	
	ACC16CLC
	lda	[longp]
	inc	a
	inc	a
	bit	#$0001
	beq	?01
	inc	a
?01:	sta	cmdlin
	adc	#128		; size of command line
	ACC08
	xba
	;ldy	#1
	;lda	[longp],y
	tax
	inx
	;inx
	ldy	#0
	lda	#1
	sta	autolf
	;inc	a
	sta	tmpdsk
	lda	#$04
	sta	defprn
	lda	#$80
	sta	pcdbg		; for RUN ???
	;sta	pcdsk
	;stz	pcdsk
	lda	#$80
	bra	pccrun

; memory setup
; X = start of heap, Y = start of p-code, A = run flag
setmem:
	sta	runf		; run flag
	STZ	$33		; $33-$34 : start of heap
	STX	$34	
	STZ	$35		; $35-$36 : heap free list
	STZ	$36
	STZ	$39		; $39-$3A
	STZ	$3A
	LDA	#$02
	STA	$2B		; $2B-$2C : start p-code pointer
	STY	$2C
	jsr	FCLALL		; close all files
	lda	vbnk
	sta	svbnk		; save v-bank
	bit	runf
	bmi	?01		; run: data bank = vbank
	lda	cbnk		; compilation: data bank = cbnk
	sta	vbnk
?01:	pha
	plb			; setup current data bank
	ldx	#$00
?02:	stz	!MINBUF,x	; clear working area
	inx
	bne	?02
	ACC16
	lda	txttop
	sta	$37
	SEC
	SBC	#$000A
	STA	$2D		; $2D-$2E : stack pointer
	LDA	$37
	STA	$2F		; $2F-$30
	STA	$31		; $31-$32
	SEC
	SBC	#$0004
	STA	$27
	lda	#MSTDF1+2	; default file #1 (disk command channel)
	sta	($27)
	ldy	#2
	lda	#MSTDF0+2	; default file #0 (consolle)
	sta	($27),y
	stz	psrline
	lda	#MSTDF0+2
	sta	!MFILET
	lda	#MSTDF1+2
	sta	!MFILET+2
	ldx	runf
	bpl	?03
	stz	!MFILET+4	; file #2 free in running mode
	bra	?04
?03:	lda	#MSTDF2+2	; set file #2 for compiler
	sta	!MFILET+4	
?04:	ACC08
	LDX	#TTMPSIZ-1
?05:	LDA	>TTMPNAM,X
	STA	!MTMPNAM,X
	DEX
	BPL	?05
	lda	tmpdsk		; setup disk for tmp. file
	ora	#'0'
	sta	!MTMPNAM
	lda	#$C0
	sta	prtrap
	stz	prterr
	stz	pbrkcnt
	stz	pcterr
	STZ	$B7
	LDA	#$01
	STA	$B8
	LDA	#$08
	STA	$BA
	LDA	#$0F
	STA	$B9
	JSR	FOPEN
	jsr	RDTIM
	STA 	$41
	stz	$42
	stz	inqidx
	stz	inqcnt
	stz	tmpy
	stz	tmpa
	stz	tmpv1
	stz	tmpv2
	stz	tmpwa
	stz	tmpx
	;stz	iecerr
	stz	kstat

	bit	runf
	bmi	?12		; run mode
	
	; source name for compiler in [longp]
	ACC16
	lda	#PASSRC
	sta	longp
	ACC08
	lda	xbnk
	sta	longp+2
	
	ldy	#0		; copy file name to internal buffer
?10:	lda	[longp],y
	sta	MINBUF,y
	beq	?11
	iny
	bne	?10
?11:	rts

?12:	ACC16
	lda	txtp
	sta	longp
	ACC08
	lda	tbnk
	sta	longp+2
	ldy	#127
	lda	#' '
?12l:	sta	(cmdlin),y
	dey
	bpl	?12l
	iny
?13l:	lda	[longp],y
	beq	?13
	sta	(cmdlin),y
	iny
	cpy	#128
	bcc	?13l
?13:	rts

; execute p-code
pcex:
	INDEX16
	tsx
	stx	pcstack   
	INDEX08
?04:	dec	pbrkcnt
	bne	?06
	jsr	L0E91		; check CTRL BREAK
?06:	ACC16
	pea	#?04-1		; return address
	lda	($2B)
	tax
	lda	$2B
	sta	pcptr		; save p-code pointer
	inc	a
	sta	$2B
	ACC08
	LDY	#$00
	txa
	BMI	?14		; >= 80 
?08:	ASL	a
	TAX
	BPL	?12		; 00..3F -> 0 byte
	CMP	#$A0
	BCC	?10		; 40..4F -> 2 bytes
	AND	#$02		; 50..7F
	BEQ	?10		; EVEN -> 50,52,54,56... -> 2 bytes
	LDA	($2B)		; ODD  -> 51,53,55,57... -> 1 byte (byte high = 00)
	STA	$23
	INC	$2B
	BNE	?09 
	INC	$2C
?09:	STY	$24
	bra	?12 
?10:	ACC16	
	LDA	($2B)
	STA	$23
	lda	$2B
	inc	a
	inc	a
	sta	$2B
	ACC08
?12:	jmp	(PCODET1,x)

?14:	; code negative
	; P80-8D -> 0 byte, 8E -> 1 byte, 8F -> 2 bytes
	AND	#$0F
	CMP	#$0E
	STA	$23
	STY	$24
	BMI	?16
	PHP
	LDA	($2B)
	STA	$23
	INC	$2B
	BNE	?15
	INC	$2C
?15:	PLP
	BEQ	?16
	LDA	($2B)
	STA	$24
	INC	$2B
	BNE	?16
	INC	$2C
?16:	TXA
	LSR	a
	LSR	a
	LSR	a
	AND	#$0E
	TAX
	LDA	>PCODET2,X
	STA	$27
	LDA	>PCODET2+1,X
	STA	$28
	LDA	$23
	LDX	$24
	JMP	(CBMP0+$27)
	
; error: bad p-code
vpme07:
	LDX 	#$07

; runtime error handler
vpmerr:	; $0C78 - $0F0D
	pha			; dummy stack
	pha
	stx	$3E		; error code
	JSR	FCLRCH
	STZ	$3B
	lda	$29		; save current file desc
	sta	fbufpt
	lda	$2A
	sta	fbufpt+1
	JSR	L0F9B		; reset file #1 and print CR
	ldx	$3E
	jsr	vpmsrch		; search error string
	; now format and print error message
	lda	longp+2		; param 3: error string pointer
	pha
	pei	(longp)
	lda	$3E		; param 2: error code
	pha
	lda	#^STRFMT2	; param 1: format string
	pha
	pea	#STRFMT2
	lda	#$08		; param 0: number of total bytes
	pha
	BPRINTF
vpmerr2:
?08:	;;JSR	lprint		; long print error string
	bit	runf
	bpl	?12		; running: print always line number
	; now format line number
	pei	($3F)		; param 2: line number
	lda	#^STRFMT3
	pha			; param 1: format string
	pea	#STRFMT3
	lda	#$06		; param 0: number of total bytes
	pha
	BPRINTF

?10:	;;LDA	#<TLINS		; ',line '
	;;STA 	longp
	;;LDA	#>TLINS
	;;STA	longp+1
	;;JSR	lprint
?12:	;;LDA	#<MDFIL+6		; M2D92 - m35D8
	;;STA	$29
	;;LDA	#>MDFIL+6
	;;STA 	$2A
	;;bit	runf
	;;bpl	?14		; running: print always line number	 
?13:	;;LDA 	$3F		; line number
	;;STA	$21
	;;LDA	$40
	;;STA	$22
	;;LDA 	#$00
	;;STA	$23
	;;JSR	L0D1C
?14:	JSR	L0E89		; print CR
	; report debug info after error - always for compiler
	bit	runf
	bpl	?15
	bit	pcdbg		; when run: only if debug enabled
	bpl	?16
?15:	pei	(fbufpt)	; param 8: saved file ptr
	pei	($33)		; param 7: heap ptr
	pei	($2D)		; param 6: stack ptr
	lda	(pcptr)
	pha			; param 5: op-code
	pei	($2B)		; param 4: current p-code ptr
	pei	(pcptr)		; param 3: p-code ptr at error
	lda	vbnk
	pha			; param 2: data bank
	lda	#^STRFMT4
	pha			; param 1: format string
	pea	#STRFMT4
	lda	#$10		; param 0: number of total bytes
	pha
	BPRINTF
	JSR	L0E89		; print CR
?16:	lda	#$80		; report error for compiler
	sta	pcterr

; terminate pascal virtual machine
vpmhlt:	; $0914 - $0AC4
	; if pcterr = $80 this mean compiler error(s)
	bit	runf
	bmi	?02		; execution
	jsr	L0942		; close all files
	bit	pcterr		; check compiler error
	bpl	?01		; no error
	; delete file .OBJ
	lda	#$01
	jsr	FCLOSE		; close command channel
	ACC16
	lda	#NUMSTR+1
	sta	$BB		; file name to delete
	ACC08
	lda	tbnk		; text bank hold file name
	sta	$BD
	phb
	pha
	plb
	lda	!NUMSTR		; lenght
	sta	$B7
	plb
	lda	#$01
	sta	$B8
	lda	#$0F
	sta	$B9
	lda	#$08
	sta	$BA
	jsr	FOPEN		; delete obj file
?01:	lda	#1		; close file #1
	bra	?04
?02:	jsr	R0B28		; close all files	
	LDA 	#$08		; delete any tmp file
	STA 	$BA		; default disk
	STA 	$B8
	LDA 	#$0F
	STA 	$B9
	INDEX16
	ldx	#DTMPNAM	; copy temp. name
	stx	longp	
	ldx	#GFNAME		; buffer temp. name
	stx	$BB
	INDEX08
	lda	#^vpmhlt
	sta	longp+2
	lda	tbnk
	sta	$BD
	ldy	#$FF
?03:	iny
	lda	[longp],y
	sta	[$BB],y
	bne	?03
	sty	$B7
	ldy	#$01
	lda	tmpdsk
	ora	#'0'
	sta	[$BB],y		; 'SX:...'
	JSR 	FOPEN
	LDA 	$B8
?04:	JSR 	FCLOSE
	INDEX16
	LDX 	pcstack   
	TXS
	INDEX08
	RTS 

; search error string - X = error code
; return pointer in longp
vpmsrch:
	LDA 	#<TERRS		; error's string table 
	STA	longp
	LDA 	#>TERRS
	STA	longp+1
	lda	#^vpmerr
	sta	longp+2
	cpx	#MAXVPME	; max error number
	bcc	?02
	ldx	#MAXVPME	
?02:	DEX
	BEQ	?08
?04:	LDA	[longp]
	INC 	longp
	BNE	?06
	INC	longp+1
?06:	tay
	BNE	?04
	BEQ	?02
?08:	RTS

;---------------------------------------------------------------------------
; p-code linker
;---------------------------------------------------------------------------

pclink:
	.GLOBAL pclink

	lda	vbnk
	pha
	plb
	stz	$5F
	stz	$60
	stz	prterr
	stz	longp
	stz	longp+1
	lda	jbnk
	sta	longp+2		; pointer to obj. code
	stz	$35
	stz	$36
	stz	$23
	stz	$24
	lda	#$02		; put 'halt'
	sta	!$0002
?02:	ldx	$24		; loop scan obj. code
	inx
	cpx	$38
	beq	?08
	ldy	#0	
?03:	ACC16CLC
	tya
	adc	longp
	cmp	iecwp
	ACC08
	lda	longp+2
	sbc	iecwp+2
	bcs	?05		; end of obj. code
	lda	[longp],y
	sta	($23),y
	iny
	bne	?03
	inc	longp+1		; next block
	bne	?04
	inc	longp+2	
?04:	ldy	#$FC
	lda	($23),y
	beq	?10		; if = 0
	cmp	#$01
	beq	?12		; if = 1
	cmp	#$02
	bne	?02
	jmp	?20		; if = 2

?05:	ACC16
	lda	$35
	beq	?07
	lda	($35)
	sta	$27
	lda	#$FFFF
	sta	($35)
	lda	$27
	sta	$35
	ACC08
	xba
	bne	?05
?07:	ACC08
	rts

?08:	lda	#$80
	sta	pcterr
	rts

?10:	ldy	#$FE
	lda	($23),y
	clc
	adc	$23
	sta	$23
	bcc	?02
	inc	$24
	bne	?02

?12:	ldy	#$FE
	lda	($23),y
	tax
	ldy	#$00
?14:	ACC16CLC
	lda	($23),y
	adc	$5F
	sta	$21
	iny
	iny
	sty	$27
	ACC08
	ldy	#$01
	lda	($21),y
	cmp	#$FF
	beq	?16
	ACC16CLC
	lda	($21)
	adc	$5F
	sta	($21)
	ACC08
?15:	ldy	$27
	dex
	bne	?14
	jmp	?02
?16:	ACC16
	lda	$35
	sta	($21)
	lda	$21
	sta	$35
	ACC08
	bra	?15
	
?20:	ldy	#$FE
	lda	($23),y
	lsr	a
	tax
	ldy	#0
?22:	ACC16CLC
	lda	($23),y
	adc	$5F
	sta	$21
	ACC08
	iny
	iny
	jsr	?30
	lda	($23),y
	pha
	iny
	lda	($23),y
	iny
	sty	$27
	ldy	#$01
	bcc	?24
	clc
	adc	$60
?24:	sta	($21),y
	dey
	pla
	sta	($21),y
	ldy	$27
	dex
	bne	?22
	jmp	?02

?30:	ACC16
	lda	$35
	sta	!$FFFE
	lda	#$FFFE
	sta	$25
?32:	lda	$25
	sta	$27
	lda	($27)
	sta	$25
	clc
	beq	?34
	lda	$25
	cmp	$21
	bne	?32
	lda	($25)
	sta	($27)
	sec
?34:	lda	!$FFFE
	sta	$35
	ACC08
	rts
	
;---------------------------------------------------------------------------
; p-code execution
;---------------------------------------------------------------------------

PC00:	; $1119 - $13A4
	LDA ($2D),Y
	STA $27
	INY 
	LDA ($2D),Y
	STA $28
	LDA #$00
	STA ($2D),Y
	DEY 
	LDA ($27),Y
	STA ($2D),Y
	rts

PC3B:	; $0970 - $0B81
	; 'rewrite' on disk
	JSR 	L09C2		; prepare for open
	LDA 	$3E
	BNE 	SK04		; if error
	bit	runf
	bmi	?10		; run mode
	bit	objdsk
	bmi	?01		; use disk '1': '1' option
	lda	truedsk		; need this because compiler put drive 0
	ora	#'0'
	ldy	#1
	sta	[$BB],y

	; copy obj. name file to NUMSTR in tbank
?01:	phb
	lda	$BD
	pha
	plb
	ldy	#$FF
?02:	iny	
	lda	[$BB],y
	sta	NUMSTR+1,y	
	bne	?02
	lda	#'S'		; scratch
	sta	!NUMSTR+1
	lda	$B7
	sec
	sbc	#4		; skip ',S,W'
	sta	!NUMSTR		; length
	tax
	stz	!NUMSTR+1,x
	plb
	
?10:	JSR 	FOPEN		; open
	bit	runf
	JSR 	L0A73		; handle disk error
	LDA 	#$A8
	STA 	($29)
	bra	SK04

PC01:	; $112E - $13B9
	LDA	($2D)
	TAX
	ldy	#2
	ACC16
	LDA	($2D),Y
	STA	$27
	ACC08
	TXA
	STA	($27)
	
SK04:	; $1141 - $13CC
	ACC16CLC
	LDA	$2D
	ADC	#$0004
	STA	$2D
	ACC08
	rts

PC02:	; $114F - $13DA
	; terminate procedure or program
	bit	runf
	bpl	?02
	JSR 	R0AE9		; close all local files 
?02:	CLC
	LDA 	$2F
	ADC 	#$06
	STA 	$2D
	LDA 	$30
	ADC 	#$00
	STA 	$2E
	CMP 	$32
	BCC 	?04
	LDA 	$2F
	SBC 	$31
	BCC 	?04 
	JMP 	vpmhlt		; terminate
?04:	LDY 	#$04		; exit from procedure/function
	ACC16
	LDA 	($2F),Y
	STA 	$2B
	ldy	#$02
	LDA 	($2F),Y
	STA 	$2F
	ACC08
	rts
	
PC03:	; $1185 - $1410
	; return from integer function
	bit	runf
	bpl	?02
	JSR 	R0AE9 
?02:	CPU16
	LDA 	($2D)
	TAX
	LDA 	$2F
	STA 	$2D
	iny
	iny
	LDA 	($2D),Y
	STA 	$2F
	iny
	iny
	LDA 	($2D),Y
	STA 	$2B
	txa
	STA 	($2D),Y
	CPU08
	bra	SK04

PC04:	; $11B4 - $143F
	; prepare for call procedure/function
	SEC
	ACC16
	LDA 	$2D
	SBC 	#$0006
	STA 	$2D
	LDA 	$39
	STA 	($2D)
	LDA 	$2D
	STA 	$39
	ACC08
	rts

PC09:	; $126F - 14FA
	; divide 2 integer and leave result in stack
	tyx			; Y = X = 0	
	ACC16
	LDA 	($2D)
	STA 	$25
	iny
	iny
	LDA 	($2D),y
	STA 	$23
	ACC08
	JSR 	idiv
	ACC16
	LDA 	$21
	STA 	($2D),Y
	ACC08
	bra	SK02

PC0B:	; $12F6 - $1581
	; logic 'and' 2 bytes and leave result in stack
	LDA 	($2D)
	LDY 	#$02
	AND 	($2D),Y
	STA 	($2D),Y
	bra	SK02

PC0C:	; $1301 - $158C
	; logic 'or' 2 integer and leave result in stack
	LDA 	($2D)
	LDY 	#$02
	ORA 	($2D),Y
	STA 	($2D),Y
	bra	SK02

PC05:	; $11D5 - $1460
	; add 2 integer and leave result in stack
	ACC16CLC
	LDA 	($2D)
	LDY 	#$02
	ADC 	($2D),Y
	STA 	($2D),Y
SK02:	; $11E7 - $1472
	ACC16CLC
	LDA 	$2D
	inc	a
	inc	a
	STA 	$2D
	ACC08
	rts

PC06:	; $11F5 - $1480
	; subctract 2 integer and leave result in stack
	ACC16
	ldy	#2
	sec
	LDA 	($2D),y
	sbc 	($2D)
	STA 	($2D),Y
	ACC08
	bra	SK02
	
PC07:	; $1210 - $149B
	; mult 2 integer and leave result in stack
	tyx			; Y = X = 0
	CPU16
	LDA 	($2D)
	STA 	$23
	pha
	bpl	?02
	sec
	txa			; X = 0
	sbc	$23
	sta	$23
?02:	iny
	iny
	LDA 	($2D),Y
	STA 	$25
	bpl	?04
	sec
	txa			; X = 0
	sbc	$25
	sta	$25
?04:	PLA 
	EOR 	($2D),Y		; sign comparison
	CPU08
	PHP
	JSR 	imult		; return Z = 0 if CF = 0
	BCS 	er03 
	LDA 	$22
	BMI 	er03
	PLP
	CPU16
	BPL	?06
	sec
	txa			; X = 0
	sbc	$21
	sta	$21
?06:	lda	$21	
	STA 	($2D),Y
	CPU08
	bra	SK02

PC08:	; $124D - $14D8
	; compute modulo 2 integer and leave result in stack
	ACC16
	LDA 	($2D)
	STA 	$25
	iny
	iny
	LDA 	($2D),Y
	STA 	$23
	ACC08
	JSR 	idiv
	ACC16
	LDA 	$23
	STA 	($2D),Y
	ACC08
	bra	SK02

PC0A:	; $1291 - $151C
	; 2's complement integer and leave result in stack
	CPU16
	SEC
	TYA
	SBC 	($2D)
	STA 	($2D)
	CPU08
	rts

; integer overflow	
er03:	; $12A0 - $152B
	LDX 	#$03
	JMP 	vpmerr

; divide integer $23-$24 and $25-$26 - quot. in $21-$22 and rem. in $23-$24
; in input X must be 0
idiv:
	LDA 	$25
	ora	$26
	BEQ 	er03
	STZ	$21
	STZ	$22
	lda	$24
	eor	$26
	PHP
	CPU16
	LDA 	$23
	BPL	?02
	sec
	txa			; X = 0
	sbc	$23
	sta	$23
?02:	LDA 	$25
	BPL 	?04
	sec
	txa			; X = 0
	sbc	$25
	sta	$25
?04:	CPU08
	LDX	#$10
?06:	ASL 	$23
	ROL 	$24
	ROL 	$21
	ROL 	$22
	BMI 	er03
	LDA 	$21
	CMP 	$25
	LDA 	$22
	SBC 	$26
	BMI 	?08 
	STA 	$22
	LDA 	$21
	SEC 
	SBC 	$25
	STA 	$21
	LDA 	$23
	ORA 	#$01
	STA 	$23
?08:	DEX 
	BNE 	?06
	PLP 
	BPL 	?10
	CPU16
	sec
	txa			; X = 0
	sbc	$21
	sta	$21
	sec
	txa			; X = 0
	sbc	$23
	sta	$23
	CPU08
?10:	RTS 

PC0D:	; $xxxx - $2959
	; page() procedure
	bit	runf
	bpl	PC0Dx
	JSR	L17A3
	JSR	R0F8D
	DEC	$B8
	BEQ	?02		; output (clear screen) 
	JSR	L0EA8
	LDA	#$0C		; new page at printer
	JSR	L0EC4
	jsr	FCLRCH
	bra	?04
?02:	nop			; clear screen
	SCNCLR			; call system function
?04:	LDA	#$02
	CLC 
	ADC	$2D
	STA	$2D
	BCC	?06 
	INC	$2E
?06:	rts

PC0Dx:
	JMP 	vpme07		; error: bad p-code

PC14:	; $xxxx - $2BDF		; close file
	bit	runf
	bpl	PC0Dx
	LDA 	($2D),Y
	STA 	$29
	INY 
	LDA 	($2D),Y
	STA 	$2A
	JSR	R0F8D
	LDA	$B8
	CMP	#$FF
	BEQ	?02 
	ASL	a
	TAX
	LDA	#$00
	STA	!MFILET,X
	STA	!MFILET+1,X
	LDA	$B8
	JSR	FCLOSE
?02:	JMP	SK02

PC0E:	; $130C - $1597
	LDA 	($2D)
	EOR 	#$01
	STA 	($2D)
	rts
	
PC0F:	; $1315 - $15A0
	LDA 	($2D),Y
	LDY 	#$02
	CMP 	($2D),Y
	INY 
	LDA 	($2D),Y
	EOR 	#$80
	STA 	$27
	LDY 	#$01
	LDA 	($2D),Y
	EOR 	#$80
	SBC 	$27
	LDY 	#$03
	BCC 	PC11c 
	BCS 	PC11a

PC10:	; $1330 - $15BB
	LDY 	#$02
	LDA 	($2D),Y
	LDY 	#$00
	CMP 	($2D),Y
	INY 
	LDA 	($2D),Y
	EOR 	#$80
	STA 	$27
	LDY 	#$03
	LDA 	($2D),Y
	EOR 	#$80
	SBC 	$27
	BCC 	PC11c 
	BCS 	PC11a 

PC11:	; $134B - $15D6
	LDA 	($2D),Y
	LDY 	#$02
	CMP 	($2D),Y
	BNE 	PC11b 
	DEY 
	LDA 	($2D),Y
	LDY 	#$03
	CMP 	($2D),Y
	BNE 	PC11c 
PC11a:	; $135C - $15E7
	LDA 	#$00
	STA 	($2D),Y
	DEY 
	LDA 	#$01
	STA 	($2D),Y
	JMP 	SK02
PC11b:	; $1368 - $15F3
	INY 
PC11c:	; $1369 - $15F4
	LDA 	#$00
	STA 	($2D),Y
	DEY 
	STA 	($2D),Y
	JMP 	SK02

PC12:	; $1373 - $15FE
	JSR 	decstk
	LDY 	#$03
	LDA 	($2D),Y
	LDY 	#$01
	STA 	($2D),Y
	INY 
	LDA 	($2D),Y
	STA 	($2D)
	rts

decstk:	; $1836 - $1ABF
	LDA 	$2D
	SEC 
	SBC 	#$02
	STA 	$2D
	BCS 	?02 
	DEC 	$2E
?02:	RTS 

PC13:	; $1388 - $1613
	LDY 	#$11
	LDA 	($2D),Y
	BNE 	?04 
	DEY 
	LDA 	($2D),Y
	BMI 	?04 
	TAX 
	LSR	a 
	LSR	a 
	LSR	a 
	TAY 
	TXA 
	AND 	#$07
	TAX 
	LDA 	($2D),Y
?02:	ROR 	a
	DEX 
	BPL 	?02 
	BCC 	?04 
	LDY 	#$10
	LDA 	#$01
	STA 	($2D),Y
	BNE 	?06 
?04:	LDY 	#$10
	LDA 	#$00
	STA 	($2D),Y
	INY 
	STA 	($2D),Y
?06:
L13B5:	; $13B5 - $1640
	LDA 	$2D
	CLC 
	ADC 	#$10
	STA 	$2D
	BCC 	?08 
	INC 	$2E
?08:	
PCxx:	rts

PC15:	; $13C3 - $164E
	JSR	L1762
	JSR	L0D1C
	JMP	FCLRCH

PC16:	; $13CF - $165A
	JSR	L1762
	LDA	$23
	BEQ	PCxx 
	LDX	#$01
	JSR	L0E69
	LDA	$21
	JSR	L0EC4
	JMP	FCLRCH

PC19:	; $1421 - $16AC
	; write CR to text file
	STY	$3E
	JSR	L17AD
	JSR	L0EA8
	LDA	#$0D
	JSR	L0EC4

	lda	dflto
	cmp	#$03
	beq	?02
	LDA	#$0A
	JSR	L0EC4
?02:	
	JSR	FCLRCH
	JMP	SK02

PC1A:	; $1434 - $16BF
	; read integer from input text file
	JSR	L178B
	JSR	L0DA5
	BCC	?02 
	LDX	#$02
	JSR	L0FAA
?02:
L1441:	; $1441 - $16CC
	JSR	L17B7
L1444:	; $1444 - $16CF
	LDA	$21
	LDY	#$00
	STA	($2D),Y
	INY
	LDA	$22
	STA	($2D),Y
	JMP	FCLRCH

PC1B:	; $1455 - $16E0
	STY	$22
	JSR	L178B
	STA	$21
	LDY	#$00
	LDA	($29),Y
	AND	#$40
	BNE	L147F 
?02:	JSR	L0F2B
	CMP	#$0A
	BEQ	?02 
	BNE	L1441 

; redln
PC1C:	; $146D - $16F8
	JSR	L178B
	LDY	#$00
	LDA	($29),Y
	AND	#$40
	BNE	L147F 
?02:	JSR	L0F2B
	CMP	#$0D
	BNE	?02
	
L147F:	; $147F - $170A
	LDY	#$00
	LDA	($29),Y
	ORA	#$02
	STA	($29),Y
	bra 	L1444

L0DA5:	; $0DA5 - $1030
	bra	?04
?02:	JSR	L0F2B
?04:	CMP	#$0D
	BEQ	?02 
	CMP	#$20
	BEQ	?02 
	CMP	#$0A
	BEQ	?02 
	LDX	#$00
	STX	$21
	STX	$22
	CMP	#$2D		; minus sign
	PHP
	BEQ	?06
	CMP	#$2B
	BNE	?08		; plus sign 
?06:	JSR	L0F2B
?08:	CMP	#$3A
	BPL	?18 
	SEC
	SBC	#$30
	BMI	?18 
?10:	PHA
	ASL	$21
	ROL	$22
	LDA	$21
	LDY	$22
	ASL	$21
	ROL	$22
	ASL	$21
	ROL	$22
	CLC
	ADC	$21
	STA	$21
	TYA
	ADC	$22
	STA	$22
	PLA
	CLC 
	ADC	$21
	STA	$21
	BCC	?12 
	INC	$22
?12:	JSR	L0F2B
	TAX
	CMP	#$3A
	BPL	?14 
	SEC 
	SBC	#$30
	BPL	?10 
?14:	PLP
	BNE	?16 
	SEC 
	LDA 	#$00
	SBC	$21
	STA	$21
	LDA	#$00
	SBC	$22
	STA	$22
?16:	TXA
	CLC
	RTS
?18:	PLA
	TXA
	SEC
	RTS 

PC1D:	; $29C1 - $2FA3
	; read a floating point number from text file
	JSR	L178B
	LDX	#$00
	STX	$3E
?02:	CMP	#$20
	BEQ	?04 
	CMP	#$0D
	BEQ	?04 
	CMP	#$0A
	BNE	?08 
?04:	JSR	L0F2B
	bra	?02
?06:	JSR	L0F2B
?08:
?10:	STA	!MNUMSTR,X	; buffer
	STA	$27		; last char was read
	INX
	CPX	#NUMSIZ-1
	BEQ	?26
	CMP	#$2E
	BEQ	?06 
	CMP	#'E'
	BEQ	?06
	CMP	#'e'
	BEQ	?06	
	CMP	#$2B
	BEQ	?06 
	CMP	#$2D
	BEQ	?06
	CMP	#$30
	BCC	?12
	CMP	#$3A
	BCC	?06
?12:	DEX
?14:	BEQ	?26 
	LDA	#$00
	STA	!MNUMSTR,X
	ACC16
	pei	($7A)
	LDA	#MNUMSTR
	STA	$7A
	ACC08
	JSR	XBCF3P
	TAX			; X = return code from conversion 
	ACC16
	pla
	STA	$7A
	ACC08	
	TXA
	BEQ	?28 
?26:	LDX	#$0A		; floating point read error
	JSR	L0FAA
?28:	LDA	$2D
	SEC
	SBC	#$04
	STA	$2D
	BCS	?30
	DEC	$2E
?30:	LDY	$2E
	TAX
	JSR	XBBD4
	LDA	$27
	JSR	L17B7
	JMP	FCLRCH

PC1E:	; $2825 - $2E07
	; write float number to text file - float point format
	LDA	($2D),Y
	BMI	?02
	BNE	?04
?02:	LDA 	#$01
?04:	PHA
	LDY	#$0A
	JSR	L17AD
	JSR 	L0EA8
	LDA 	$2D
	CLC
	ADC	#$04
	LDY	$2E
	BCC	?06
	INY
?06:	JSR	XBBA2
	LDA	$66
	PHA
	JSR	L2891
	PLA
	STA	$66
	PLA
	STA	$25
	CLC
	ADC	tmpv2
	BMI	?08
	BNE	?10
?08:	LDA	#$01
?10:	STA	$23
	JSR	L290B
	BCC	?12
	INC	tmpv2
?12:	LDA	tmpv2
	STA	$23
	CMP	#$01
	BPL	?14
	LDA	#$01
?14:	CLC
	ADC	$25
	ADC	#$02
	LDY	#$02
	SEC
	SBC	($2D),Y
	TAX
	BPL	?18
	LDA	#$20
?16:	JSR	L0EC4
	INX
	BNE	?16
?18:	JSR	L29B6
	JSR	L2948
	JSR	FCLRCH
	LDA	#$0C
	JMP	L155E

PC1F:	; $27AC - $2D8E
	; write float number to text file - exponential format
	LDA 	($2D),Y
	PHA 
	LDA 	$2D
	CLC 
	ADC 	#$02
	LDY 	$2E
	BCC	?02
	INY 
?02:	JSR	XBBA2
	LDY	#$08
	JSR 	L17AD
	JSR	L0EA8
	JSR	L29B6
	JSR	L2891
	PLA 
	SEC
	SBC	#$06
	CMP	#$02
	BPL	?04
	LDA	#$02
?04:	STA	$23
	STA	$25
	JSR	L290B
	BCC	?06
	INC	tmpv2
?06:	DEC	$25
	LDA	#$01
	STA	$23
	JSR	L2948
	LDA	#$45
	JSR	L0EC4
	DEC	tmpv2
	LDA	#$2B
	BIT	tmpv2
	BPL	?08
	LDA	#$00
	SEC
	SBC	tmpv2
	STA	tmpv2
	LDA	#$2D
?08:	JSR	L0EC4
	LDX	#$2F
	LDA	tmpv2
?10:	INX
	SEC
	SBC	#$0A
	BPL	?10
	PHA
	TXA
	JSR	L0EC4
	PLA 
	CLC
	ADC	#$3A
	JSR	L0EC4
	JSR	FCLRCH
	LDA	#$0A
	JMP	L155E

L2891:	; $2891 - $2E73
	LDA	#$00
	STA	tmpv2
?02:	LDA 	$61
	BEQ	?06
	BMI	?04
	JSR	XBAE2		; mult * 10
	DEC	tmpv2
	bra	?02
?04:	LDA	$61
	CMP	#$81
	BCC	?06
	JSR	XBAFE		; div / 10
	INC	tmpv2
	bra	?04
?06:
?07:	LDA	$61
	BMI	?08
	LSR	$62
	ROR	$63
	ROR	$64
	ROR	$65
	INC	$61
	BPL	?07
?08:	LDX	#$09
	LDA 	#$00
?10:	STA	!MNUMSTR,X
	DEX 
	BPL	?10
	LDY	#$20
?12:	LDX	#$00
?14:	LSR	!MNUMSTR,X
	INX
	PHP
	CPX	#$0A
	BEQ	?16
	PLP 
	BCC	?14
	LDA	!MNUMSTR,X
	ADC	#$09
	STA	!MNUMSTR,X
	BNE	?14
?16:	PLP 
	LSR	$62
	ROR	$63
	ROR	$64
	ROR	$65
	BCC	?18
	LDA	!MNUMSTR
	ADC	#$04
	STA	!MNUMSTR
?18:	DEY
	BNE	?12
	RTS
	
L290B:	; $290B - $2EED
	LDA	$23
	BMI	?06
	BEQ	?06
	CMP	#$0A
	BCS	?06
	TAX 
	LDA	!MNUMSTR,X
	CLC
	ADC	#$05
	STA	!MNUMSTR,X
?02:	LDA	!MNUMSTR,X
	SEC
	SBC	#$0A
	BMI	?04
	STA	!MNUMSTR,X
	DEX
	BMI	?10
	INC	!MNUMSTR,X
	INX
?04:	DEX
	BPL	?02
?06:	CLC 
?08:	RTS
?10:	LDX	$23
?12:	SEC
	LDA	#$01
	DEX
	BMI	?08
	BEQ	?14
	LDA	!MNUMSTR-1,X
?14:	STA	!MNUMSTR,X
	BCS	?12		; here always CF = 1

L2948:	; $2948 - $2F2A
	LDX	#$00
	LDA	$23
	BEQ	?06 
	BMI	?06 
?02:	LDA	#$00
	CPX	#$0A
	BEQ	?04 
	LDA	!MNUMSTR,X		; buffer
	INX
?04:	CLC
	ADC	#$30
	JSR	L0EC4
	DEC	$23
	BNE	?02 
	LDA	#$2E
	JSR	L0EC4
	bra	?12
?06:	LDA	#$30
	JSR	L0EC4
	LDA	#$2E
	JSR	L0EC4
	LDA	#$00
	SEC
	SBC	$23
	STA	$23
	BEQ	?12 
	LDA	$25
	SEC 
	SBC 	$23
	CMP 	#$01
	BPL	?08 
	LDA	$25
	STA 	$23
	LDA	#$00
?08:	STA	$25
	LDA	$23
	BEQ	?12 
	LDA	#$30
?10:	JSR	L0EC4
	DEC	$23
	BNE	?10 
?12:	LDA	$25
	BEQ	?18 
?14:	LDA	#$00
	CPX	#$0A
	BEQ	?16 
	LDA	!MNUMSTR,X		; buffer
	INX
?16:	CLC
	ADC	#$30
	JSR	L0EC4
	DEC	$25
	BNE	?14 
?18:	RTS

PC20:	; $2AC1 - $30A3
	JSR 	L2B26
	LDY 	#$04
L2AC6:	; $2AC6 - $30A8
	LDA 	($2D),Y
	STA 	$27
	INY 
	LDA 	($2D),Y
	STA 	$28
	STA 	$23
	BPL 	?02 
	LDA 	#$00
	SEC 
	SBC 	$27
	STA 	$27
	LDA 	#$00
	SBC 	$28
	STA 	$28
?02:	LDA 	#$00
	DEY 
	STA 	($2D),Y
	DEY 
	STA 	($2D),Y
	LDX 	#$90
?04:	BIT 	$28
	BMI 	?06 
	ASL 	$27
	ROL 	$28
	DEX 
	BMI 	?04 
	LDX 	#$00
?06:	DEY 
	LDA 	$27
	STA 	($2D),Y
	LDA 	$28
	BIT 	$23
	BMI 	?08 
	AND 	#$7F
?08:	DEY 
	STA 	($2D),Y
	TXA 
	DEY 
	STA 	($2D),Y
	rts

PC21:	; $2B0E - $30F0
	JSR 	L2B26
?01:	INY 
	INY 
	INY 
	INY 
	LDA 	($2D),Y
	DEY 
	DEY 
	DEY 
	DEY 
	STA 	($2D),Y
	INY 
	CPY 	#$06
	BNE 	?01 
	LDY 	#$0A
	BNE 	L2AC6 

L2B26:	; $2B26 - $3108
	LDA 	$2D
	SEC 
	SBC 	#$04
	STA 	$2D
	BCS 	?01 
	DEC 	$2E
?01:	RTS 

PC22:	; $2B90 - $3172
	JSR 	L2BA8
	JSR 	L2C0C
	JSR 	XB86A
	bra	L2BF3

PC23:	; $2B9C - $317E
	JSR 	L2BA8
	JSR 	L2C0C
	JSR 	XB853
	bra	L2BF3

PC24:	; $2BDE - $31C0
	LDY 	#$00
	LDA 	($2D),Y
	EOR 	#$80
	BMI 	?02 
	SEC 
	LDY 	#$06
	ADC 	($2D),Y
	BCS 	er09 
?02:	JSR 	L2C0C
	JSR 	XBA2B
L2BF3:	; $2BF3 - $31D5
	LDA 	$2D
	CLC 
	ADC 	#$06
	STA 	$2D
	BCC 	?02 
	INC 	$2E
?02:	LDY 	$2E
	TAX 
	JMP 	XBBD4

PC25:	; $2BB7 - $3199
	LDA 	($2D),Y
	BEQ 	er09 
	LDY 	#$06
	LDA 	($2D),Y
	LDY 	#$00
	SEC 
	SBC 	($2D),Y
	BCC 	?02 
	ADC 	#$81
	BCS 	er09
?02:	JSR 	L2C0C
	JSR 	XBB12
	bra 	L2BF3

er09:
	LDX 	#$09		; floating point overflow
	JMP 	vpmerr

PC26:	; $2C41 - $3223
	JSR 	L2C4A
	CMP 	#$FF
	BEQ 	L2C25 
	BNE 	L2C28 

PC27:	; $2C38 - $321A
	JSR 	L2C4A
	CMP 	#$01
	BEQ 	L2C25 
	BNE 	L2C28 

PC28:	; $2C20 - $3202
	JSR 	L2C4A
	BEQ 	L2C28 
L2C25:	; $2C25 - $3207
	LDA 	#$00
	bra	L2C2A 
L2C28:	; $2C28 - $320A
	lda	#$01
L2C2A:	
	LDY 	#$0A
	STA 	($2D),Y
	INY 
	LDA 	#$00
	STA 	($2D),Y
	LDA 	#$0A
	JMP 	L155E

PC29:	; $2BD3 - $31B5
	LDY 	#$01
	LDA 	($2D),Y
	EOR 	#$80
	STA 	($2D),Y
	rts

L2BA8:	; $2BA8 - $318A
	LDA 	($2D),Y
	CMP 	#$FF
	BEQ 	er09 
	LDY 	#$06
	LDA 	($2D),Y
	CMP 	#$FF
	BEQ 	er09 
	RTS 

L2C0C:	; $2C0C - $31EE
	LDA 	$2D
	LDY 	$2E
	JSR 	XBBA2
	LDA 	$2D
	LDY 	$2E
	CLC 
	ADC 	#$06
	BCC 	?02 
	INY 
?02:	JMP 	XBA8C

L2C4A:	; $2C4A - $322C
	LDA 	$2D
	CLC 
	ADC 	#$06
	LDY 	$2E
	BCC 	?01 
	INY 
?01:	JSR 	XBBA2
	LDA 	$2D
	LDY 	$2E
	JMP 	XBC5B

PC3A:	; $175B - $19E6
	JSR 	L17A3
	LDA 	#$80
	BNE 	L1749 

PC2A:	; $1744 - $19CF
	JSR 	L17A3
	LDA 	#$40
L1749:	; $1749 - $19D4
	LDY 	#$00
	AND 	($29)
	BEQ 	?02 
	LDA 	#$01
?02:	STA 	($2D)
	LDA 	#$00
	INY 
	STA 	($2D),Y
	rts

PC2B:	; $2B32 - $3114
	LDA 	$2D
	LDY 	$2E
	JSR 	XBBA2
	LDA 	$2D
	SEC 
	SBC 	#$06
	STA 	$2D
	BCS 	?02 
	DEC 	$2E
?02:	LDY 	$2E
	TAX 
	JMP 	XBBD4

PC2C:	; $2B4D - $312F
	LDA 	($2D),Y
	SEC 
	SBC 	#$06
	TAX 
	INY 
	LDA 	($2D),Y
	SBC 	#$00
	TAY 
	TXA 
	JSR 	XBBA2
	JSR 	L2B26
	LDX 	$2D
	LDY 	$2E
	JMP 	XBBD4

PC2D:	; $2B6A - $314C
	LDA 	$2D
	LDY 	$2E
	JSR 	XBBA2
	LDY 	#$06
	LDA 	($2D),Y
	SEC 
	SBC 	#$06
	TAX 
	INY 
	LDA 	($2D),Y
	SBC 	#$00
	TAY 
	JSR 	XBBD4
	LDA 	#$08
	CLC 
	ADC 	$2D
	STA 	$2D
	BCC 	?02 
	INC 	$2E
?02:	rts

PC2E:	; $14B1 - $173C
	; clear set variable (16 bytes)
	SEC 
	LDA 	$2D
	SBC 	#$10
	STA 	$2D
	BCS 	?01 
	DEC 	$2E
?01:	LDY 	#$0F
	LDA 	#$00
?02:	STA 	($2D),Y
	DEY 
	BPL 	?02 
	rts

PC2F:	; $14C8 - $1753
	LDA 	($2D),Y
	STA 	$21
	INY 
	LDA 	($2D),Y
	STA 	$22
	JSR 	L1506
	JMP 	SK02
	
L1506:	; $1506 - $1791
	LDA 	$22
	BNE 	?04		; error 
	LDA 	$21
	BMI 	?04		; error 
	LSR	a 
	LSR	a 
	LSR	a 
	TAY 
	INY 
	INY 
	LDA 	$21
	AND 	#$07
	TAX 
	LDA 	#$00
	SEC 
?02:	ROL	a 
	DEX 
	BPL 	?02 
	ORA 	($2D),Y
	STA 	($2D),Y
	RTS 
?04:	LDX 	#$08		; error: set value error
	JMP 	vpmerr

PC30:	; $14D7 - $1762
	; set variable
	LDA 	($2D)
	STA 	$23
	ACC16
	LDY 	#$02
	LDA 	($2D),Y
	STA 	$21
	INY 
	LDA 	$2D
	inc	a
	inc	a
	STA 	$2D
	ACC08
?02:	LDA 	$23
	CMP 	$21
	BCC 	?04 
	JSR 	L1506
	INC 	$21
	BNE 	?02 
	INC 	$22
	bra	?02
?04:	jmp	SK02

PC31:	; $152A - $17B5
	; operator 'or' for set variable
	LDA 	($2D),Y
	STA 	MMSET,Y		; (16 bytes)
	INY 
	CPY 	#$10
	BNE 	PC31 
?02:	LDA 	($2D),Y
	ORA 	MMSET-16,Y
	STA 	($2D),Y
	INY 
	CPY 	#$20
	BNE 	?02 
	JMP 	L13B5

PC32:	; $xxxx - $29E2
	bit	runf
	bpl	PC32x
	JSR 	R29D7
?02:	LDA 	MMSET-16,Y
	EOR 	#$FF
	AND 	($2D),Y
	STA 	($2D),Y
	INY 
	CPY 	#$20
	BNE 	?02 
	BEQ 	R2A04 

PC33:	; $xxxx - $29F5
	bit	runf
	bpl	PC32x
	JSR 	R29D7
?02:	LDA 	MMSET-16,Y
	AND 	($2D),Y
	STA 	($2D),Y
	INY 
	CPY 	#$20
	BNE 	?02 
R2A04:
	LDA 	#$10
	JMP	R17E9
	
PC34:	; $xxxx - $298F
	bit	runf
	bpl	PC32x
	JSR 	R29D7
?02:	LDA 	($2D),Y
	CMP 	MMSET-16,Y
	BNE 	R29A1 
	INY 
	CPY 	#$20
	BNE 	?02 
R299E:	LDA 	#$01
	bra	R29A3
R29A1:	lda	#$00
R29A3:	LDY 	#$1E
	STA 	($2D),Y
	LDA 	#$00
	INY 
	STA 	($2D),Y
	LDA 	#$1E
	JMP 	R17E9

PC35:	; $xxxx - $29C4
	bit	runf
	bpl	PC32x
	JSR 	R29D7
?02:	LDA 	MMSET-16,Y
	EOR 	#$FF
	AND 	($2D),Y
	BNE 	R29A1 
	INY 
	CPY 	#$20
	BNE 	?02 
	BEQ 	R299E 

PC32x:	
	JMP 	vpme07		; error: bad p-code

PC36:	; $xxxx - $29B1
	bit	runf
	bpl	PC32x
	JSR 	R29D7
?02:	LDA 	($2D),Y
	EOR 	#$FF
	AND 	MMSET-16,Y
	BNE 	R29A1 
	INY 
	CPY 	#$20
	BNE 	?02 
	BEQ 	R299E

PC3C:	; $xxxx - $2B47
	; 'reset' for generic device
	bit	runf
	bpl	PC32x		; error if compiler
	JSR 	R2B84		; open device
	LDY 	#$03
	LDA 	($2D),Y		; high byte of secondary address
	BNE 	?02
	LDA 	#$A0
	bra	?04 
?02:	lda	#$A4
?04:	STA 	($29)
R2B59:
	LDA 	$2D
	CLC 
	ADC 	#$08
	STA 	$2D
	BCC 	?02 
	INC 	$2E
?02:	rts

PC3D:	; $xxxx - $2B67
	; 'rewrite' for generic device
	bit	runf
	bpl	PC32x		; error if compiler
	JSR 	R2B84		; open device
	SEC 
	LDA 	$29
	SBC 	#$02
	STA 	$29
	BCS 	?02 
	DEC 	$2A
?02:	LDY 	#$00
	LDA 	#$20
	STA 	($29),Y
	TYA 
	INY 
	STA 	($29),Y
	INY 
	STA 	($29),Y
	bra 	R2B59			; branch always

R2B84:	; $xxxx - $2BB4
	; setup params for generic device (rewrite or reset)
	STZ 	$3E
	LDA 	($2D),Y		; offset 0: file name address
	STA 	$BB
	INY 
	LDA 	($2D),Y
	STA 	$BC
	lda	tbnk
	sta	$BD
	INY 
	LDA 	($2D),Y		; offset 2: secondary address
	STA 	$B9
	LDY 	#$04
	LDA 	($2D),Y		; offset 4: # device
	STA 	$BA
	LDY 	#$06
	LDA 	($2D),Y		; offset 6: file desc. ptr
	SEC 
	SBC 	#$03
	STA 	($2D),Y
	STA 	$29
	INY 
	LDA 	($2D),Y
	SBC 	#$00
	STA 	($2D),Y
	STA 	$2A
	LDY 	#$02
	STA 	($29),Y
	DEY 
	LDA 	$29
	STA 	($29),Y
	JSR 	R0F8D		; search file
	LDA 	$B8
	BMI 	?02		; not found 
	JSR 	FCLOSE
	bra	?04
?02:	JSR 	R0F69		; open internal logic file
?04:	LDA 	$3E
	BNE 	R29D7x		; if any error 
	LDA 	$BB
	ORA 	$BC
	BEQ 	?08		; if no filename 
	LDY 	#$00
?06:	INY 
	LDA 	[$BB],Y
	BNE 	?06 
	TYA 
?08:	STA 	$B7
	JMP 	FOPEN

R29D7:	; $xxxx - $29D7
	LDA 	($2D),Y
	STA 	MMSET,Y
	INY 
	CPY 	#$10
	BNE 	R29D7 
R29D7x:	RTS 

PC38:	; $1543 - $17CE
	LDY 	#$10
	ACC16
	LDA 	($2D),Y
	SEC 
	SBC 	#$0010
	STA 	$27
	ACC08
	LDY 	#$0F
?02:	LDA 	($2D),Y
	STA 	($27),Y
	DEY 
	BPL 	?02 
	LDA 	#$12
R17E9:
L155E:	; $155E - $17E9	
	CLC 
	ADC 	$2D
	STA 	$2D
	BCC 	?04 
	INC 	$2E
?04:	rts

PC39:	; $2A93 - $3075
	; return from real function
	LDA 	$2D
	LDY 	$2E
	JSR 	XBBA2
	ACC16
	LDA 	$2F
	STA 	$2D
	LDY 	#$02
	LDA 	($2D),Y
	STA 	$2F
	INY 
	INY 
	LDA 	($2D),Y
	STA 	$2B
	ACC08
	LDX 	$2D
	LDY 	$2E
	JMP 	XBBD4

PC52:	; $1B32 - $1DBD
PC53:
	JSR 	L1B8B
	bra	L19C1

PC58:	; $1B38 - $1DC3 
PC59:
	LDX 	#$31
	LDA 	$24
	STA 	$28
	LDA 	$23
	bra	L19C1

L19BD:
PC80:	; $19BD - $1C48	
	STX 	$28
	LDX 	#$2F
L19C1:	; $19C1 - $1C4C
	ASL	a 
	ROL 	$28
	STA 	$27
	ACC16
	LDA 	$2D
	dec	a
	dec	a
	STA 	$2D
	LDA 	<$00,X
	SEC 
	SBC 	$27
	STA 	($2D)
	ACC08
	rts

PC56:	; $1B26 - $1DB1
PC57:
	JSR 	L1B8B
	bra	PC90a

PC90:	; $195B - $1BE6
	STX 	$28
	LDX 	#$2F

PC90a:	; $195F - $1BEA
	STA 	$27
	ACC16
	INC 	$27
	ASL 	$27
	SEC
	LDA 	<$00,X
	SBC 	$27
	STA 	$27
	LDA 	$2D
	dec	a
	dec	a
	STA 	$2D
	LDA 	($27)
	STA 	($2D)
	ACC08
	rts

PC54:	; 1B2C - $1DB7
PC55:
	JSR 	L1B8B
	bra	L19E6

PCE0:	; $198F - $1C1A	
	STX 	$28
	LDX 	#$31
	BRA 	PC90a

PCA0:	; $19E2 - $1C6D	
	STX 	$28
	LDX 	#$2F

L19E6:
PCA0a:	; $19E6 - $1C71
	STA 	$27
	ACC16
	INC 	$27
	ASL 	$27
	SEC
	LDA 	<$00,X
	SBC 	$27
	STA 	$27
	LDA 	($2D)
	STA 	($27)
	LDA	$2D
	inc	a
	inc	a
	STA	$2D
	ACC08
	rts

PCF0:	; $1A17 - $1CA2
	STX 	$28
	LDX 	#$31
	BRA 	PCA0a 

PC4D:	; $1BB9 - $1E44
	; place a p-code pointer in stack
	
	bit	runf
	bmi	?02
	lda	$24
	sec
	sbc	#>PCCDST
	tax
	lda	$23
	bra	PCB0

?02:	LDA 	$23
	LDX 	$24

L1945:	
PCB0:	; $1945 - $1BD0
	; push integer AX into stack 
	xba
	txa			; byte high
	xba
	CPU16
	tay 
	LDA 	$2D
	dec	a
	dec	a
	STA 	$2D
	tya 
	STA 	($2D)
	CPU08
	rts

PCC0:	; $1995 - $1C20	
	STA 	$27
	STX 	$28
	ACC16
	INC 	$27
	ASL 	$27
	SEC
	LDA 	($2D)
	SBC 	$27
	STA 	$27
	LDA 	($27)
	STA 	($2D)
	ACC08
	rts
	
PCD0:	; $1A1D - $1CA8
	STX 	$28
	STA 	$27
	ACC16
	INC 	$27
	ASL 	$27
	SEC 
	LDY 	#$02
	LDA 	($2D),Y
	SBC 	$27
	STA 	$27
	LDA 	($2D)
	STA 	($27)
	CLC 
	LDA 	$2D
	ADC 	#$0004
	STA 	$2D
	ACC08
	rts

PC40:	; $156A - $17F5
	; absolute jmp to p-code - update p-code pointer
	ACC16
	LDA 	$23
	inc	a
	beq	?02
	dec	a
	ldx	runf
	bmi	?01
	sec
	sbc	#PCCDST
?01:	STA 	$2B
	CPU08
	rts
?02:	LDX 	#$0B		; undefined goto
_jer:	CPU08	
	JMP 	vpmerr

PC41:	; $1580 - $180B
	; absolute conditioned jmp to p-code  - update p-code pointer
	LDA 	($2D)
	ROR	a 
	BCS 	?02
	ACC16
	LDA 	$23
	ldx	runf
	bmi	?01
	sbc	#PCCDST-1	; here CF=0
?01:	STA 	$2B
	ACC08
?02:	JMP 	SK02

PC42:	; $1590 - $181B
	; 'case' jmp table - update p-code pointer
	LDX 	#$06		; case error
	SEC
	bit	runf
	ACC16
	bmi	?01
	lda	$23
	sbc	#PCCDST
	sta	$23
	bcc	_jer
?01:	LDA 	($2D)
	SBC 	($23)
	STA 	$27
	BMI 	_jer		; error 
	LDA 	$23
	inc	a
	inc	a
	STA 	$23 
	LDA 	($23)
	sec
	SBC 	($2D)
	BMI 	_jer 
	ASL 	$27
	LDA 	$23
	ADC 	$27
	STA 	$27
	LDY 	#$02
	LDA 	($27),Y
	cmp	#$FF00
	bcs	_jer		; error
	ldx	runf
	bmi	?02
	sbc	#PCCDST-1	; here CF=0
?02:	STA 	$2B
	ACC08
	JMP	SK02

PC43:	; $15F8 - $1883
	bit	runf
	bmi	?02
	sec
	lda	$24
	sbc	#>PCCDST
	sta	$24	
?02:	JSR 	L15DB
	JMP 	SK02

PC44:	; $15FE - $1889
	bit	runf
	bmi	?01
	sec
	lda	$24
	sbc	#>PCCDST
	sta	$24
?01:	LDX 	#$04		; error: array index
	JSR 	L1656
	JSR 	L1626
	LDY 	#$00
	LDA 	($23),Y
	LDY 	#$02
	EOR 	($23),Y
	LSR	a 
	BCS 	?02 
	INC 	$21
	BNE 	?02 
	INC 	$22
?02:	CLC 
	JSR 	L15E8
	JMP 	SK02

PC45:	; $161E - $18A9
	LDX 	#$05		; variable out of range
	bit	runf
	bmi	L1656
	sec
	lda	$24
	sbc	#>PCCDST
	sta	$24	
	bra 	L1656

L15DB:	; $15DB - $1866
R1866:
	LDX 	#$04		; error: array index
	JSR 	L1656
	JSR 	L1626
	ASL 	$21
	ROL 	$22
	SEC 
L15E8:	; $15E8 - $1873
	LDY 	#$02
	LDA 	($2D),Y
	SBC 	$21
	STA 	($2D),Y
	INY 
	LDA 	($2D),Y
	SBC 	$22
	STA 	($2D),Y
	RTS 

L1626:	; $1626 - $18B1
	LDY 	#$02
	SEC
	ACC16
	LDA 	($23),Y
	SBC 	($2D)
	STA 	$21
	ACC08
	LDY 	#$04
	LDA 	($23),Y
	STA 	$25
	LSR	a 
	INY 
	ORA 	($23),Y
	BEQ 	L1681 
	LDA 	($23),Y
	STA 	$26
	LDA 	$21
	STA 	$23
	LDA 	$22
	STA 	$24
	;;JMP 	imult

; mult integer $23-24 and $25-$26 and leave result in $21-$22
; $17E3 - $1A6E
imult:
	LDA 	#$00
	STA 	$21
	STA 	$22
	LDX 	#$10
?02:	ROR 	$24
	ROR 	$23
	BCC 	?04
	CLC
	LDA 	$21
	ADC 	$25
	STA 	$21
	LDA 	$22
	ADC 	$26
	STA 	$22
	BCC 	?04
	RTS 
?04:	ASL 	$25
	ROL 	$26
	DEX
	BNE 	?02
	CLC
	RTS 

L1656:	; $1656 - $18E1
	; enter with Y = 0
	LDA 	($2D),Y
	CMP 	($23),Y
	INY 
	LDA 	($23),Y
	EOR 	#$80
	STA 	$27
	LDA 	($2D),Y
	EOR 	#$80
	SBC 	$27
	BCC 	L1682 
	INY 
	LDA 	($23),Y
	LDY 	#$00
	CMP 	($2D),Y
	INY 
	LDA 	($2D),Y
	EOR 	#$80
	STA 	$27
	LDY 	#$03
	LDA 	($23),Y
	EOR 	#$80
	SBC 	$27
	BCC 	L1682 
L1681:
	RTS
L1682:
	JMP 	vpmerr

PC46:	; $1B85 - $1E10
	; call function/procedure from procedure/function at superior level
	JSR 	L1B8B
	BRA 	L1B45

PC47:	; $1B81 - $1E0C
	; call function/procedure from main program
	LDX 	#$31
	BRA 	L1B45

PC48:	; $1B43 - $1DCE
	; call nested function/procedure from procedure/function
	LDX 	#$2F
L1B45:	; $1B45 - $1DD0
	ACC16
	LDA 	($39)
	PHA 
	LDA 	<$00,X
	STA 	($39)
	INY
	INY
	LDA 	$2F
	STA 	($39),Y
	INY 
	INY 
	LDA 	$2B
	STA 	($39),Y
	LDA 	$39
	STA 	$2F
	PLA 
	STA 	$39
	LDA 	$23
	ldx	runf
	bmi	?02
	sec
	sbc	#PCCDST
?02:	STA 	$2B
	ACC08
	rts

L1B8B:	; $1B8B - $1E16
	LDA 	($2B),Y
	INC 	$2B
	BNE 	?02 
	INC 	$2C
?02:
L1B93:	; $1B93 - $1E1E
	TAX
	LDA 	$2F
	STA 	$21
	LDA 	$30
	STA 	$22
?04:	DEX 
	BMI 	?06 
	LDA 	($21),Y
	STA 	$27
	INY 
	LDA 	($21),Y
	DEY 
	STA 	$22
	LDA 	$27
	STA 	$21
	BRA	?04
?06:	LDX 	#$21
	LDA 	$24
	STA 	$28
	LDA 	$23
	RTS

PC49:	; $2D14 - $2AD5
	; compiler cause 'bad p-code' error (only in run mode)
	bit	runf
	bpl	er07
	LDA 	$23
	BEQ 	?14 
	LDA 	$2F
	STA 	$21
	LDA 	$30
	STA 	$22
?02:	LDA 	($2F),Y
	TAX 
	INY 
	LDA 	($2F),Y
	STA 	$30
	STX 	$2F
	DEY 
	DEC 	$23
	BNE 	?02 
?04:	LDY 	#$02
	LDA 	($21),Y
	TAX 
	INY 
	LDA 	($21),Y
	CPX 	$2F
	BNE 	?06 
	CMP 	$30
	BEQ 	?08 
?06:	STX 	$21
	STA 	$22
	BNE 	?04 
?08:	LDA 	$39
	ORA 	$3A
	BEQ 	?12 
	LDA 	$39
	CMP 	$2F
	LDA 	$3A
	SBC 	$30
	BCS 	?12 
	LDA 	$39
	CMP 	$21
	LDA 	$3A
	SBC 	$22
	BCC 	?10 
	LDA 	$39
	STA 	$21
	LDA 	$3A
	STA 	$22
?10:	LDA 	#$00
	;ldy	#0		; ?????
	LDA 	($39),Y
	TAX 
	INY 
	LDA 	($39),Y
	STX 	$39
	STA 	$3A
	BRA	?08
?12:	LDA 	$21
	CLC 
	ADC 	#$06
	STA 	$2D
	LDA 	$22
	ADC 	#$00
	STA 	$2E
?14:	RTS

PC4F:
er07:		
	JMP 	vpme07		; error: bad p-code

PC4A:	; $1685 - $1910
	; execute an external routine - address in $23-$24
	; in the same program bank
	jmp	(CBMP0+$23)

PC4B:	; $xxxx - $32EA (run only)
	bit	runf
	bpl	er07
	LDA 	#$04
	LDX 	#$06
	JSR 	R3335
?02:	LDY 	#$00
	LDA 	($21),Y
	STA 	($25),Y
	LDY 	#$02
	LDA 	($27),Y
	BEQ 	?04 
	INC 	$21
	BNE 	?04 
	INC 	$22
?04:	JSR 	R3399
	BNE 	?02 
	LDA 	#$04
	JMP  	R17E9

PC4C:	; $xxxx - $330D (run only)
	bit	runf
	bpl	er07
	LDA 	#$08
	LDX 	#$04
	JSR 	R3335
?02:	LDY 	#$00
	LDA 	($25),Y
	STA 	($21),Y
	LDY 	#$02
	LDA 	($27),Y
	BEQ 	?04 
	DEY 
	LDA 	#$00
	STA 	($21),Y
	INC 	$21
	BNE 	?04 
	INC 	$22
?04:	JSR 	R3399
	BNE 	?02 
	LDA 	#$06
	JMP	R17E9

PC4E:	; $200F - $2A92
	JSR 	L2027
	ACC16
	LDA 	($23)
	dec	a
	STA 	($23)
	ACC08
	rts
	
L2027:	; $2027 - $2AA6
	ACC16
	INC 	$23
	ASL 	$23
	LDA 	$2F
	SEC 
	SBC 	$23
	STA 	$23
	ACC08
	RTS 

R3335:	; $xxxx - $3335 (run only)
	PHA 
	LDA 	$2D
	PHA 
	TXA 
	CLC 
	ADC 	$2D
	STA 	$2D
	LDA 	$2E
	PHA 
	ADC 	#$00
	STA 	$2E
	LDY 	#$04
	LDA 	($23),Y
	ASL	a 
	STA 	tmpv1
	INY 
	LDA 	($23),Y
	ROL	a 
	STA 	tmpv2
	LDY 	#$00
	JSR 	R1866
	LDY 	#$02
	LDA 	($2D),Y
	SEC 
	SBC 	tmpv1
	STA 	$21
	INY 
	LDA 	($2D),Y
	SBC 	tmpv2
	STA 	$22
	PLA 
	STA 	$28
	PLA 
	STA 	$27
	LDY 	#$00
	LDA 	($27),Y
	STA 	$23
	CLC 
	ADC 	#$01
	AND 	#$FE
	STA 	$25
	INY 
	LDA 	($27),Y
	STA 	$24
	ADC 	#$00
	STA 	$26
	PLA 
	TAY 
	SEC 
	LDA 	($27),Y
	SBC 	$25
	STA 	$25
	INY 
	LDA 	($27),Y
	SBC 	$26
	STA 	$26
	RTS 

R3399:	; $xxxx - $3399 (compiler only)
	ACC16
	INC 	$21
	INC 	$25
	dec	$23
	ACC08
	lda 	$24
	ORA 	$23
	RTS

; line number (run only)
PC50:	; not in compiler - $2984
	; store line number in $3F-$40
PC51:
	bit	runf
	bmi	?02
	jmp	vpme07
?02:	LDA 	$23
	STA 	$3F
	LDA 	$24
	STA 	$40
	rts

PC5A:	; $2CF0 - $33B5
PC5B:	; simple 'new' for compiler
	ACC16
	LDA 	$2D
	dec	a
	dec	a
	STA 	$2D
	ACC08
	bit	runf
	bmi	?01
	ACC16
	ASL 	$23
	CLC 
	LDA 	$33
	ADC 	$23
	STA 	$33
	STA 	($2D)
	ACC08
	JMP 	L1A97
	; p-code execution - new
?01:	JSR 	R3511
?02:	JSR 	R3527
	BEQ 	?08
	LDY 	#$02
	LDA 	($21),Y
	SEC 
	SBC 	$23
	STA 	$25
	INY 
	LDA 	($21),Y
	SBC 	$24
	STA 	$26
	BCC 	?02 
	BNE 	?04 
	LDA 	$25
	BEQ 	?06 
	LSR	a 
	LSR	a 
	BEQ 	?02
?04:	JSR 	R3431
	ACC16
	LDY 	#$02
	LDA 	$25
	STA 	($21),Y
	lda	!MTPTR
	sta	$35
	ACC08
	rts
?06:	JSR 	R3431
	LDY 	#$00
	ACC08
	LDA 	($21),Y
	STA 	($27),Y
	lda	!MTPTR
	sta	$35	
	ACC08
	rts
?08:	ACC16CLC	
	lda	!MTPTR
	sta	$35
	LDA 	$23 
	ADC 	$33
	STA 	$33
	STA 	($2D)
	ADC 	#$0028
	CMP 	$2D
	ACC08
	BCC	PC61x
er01:
	LDX 	#$01		; stack overflow error
	JMP 	vpmerr

PC60:	; $1A86 - $1D11
PC61:	; reserve room in stack
	ACC16
	ASL 	$23
	SEC 
	LDA 	$2D
	SBC 	$23
	STA 	$2D
L1A97:	; $1A97 - $1D22	
	ACC16CLC 
	LDA 	$33
	ADC 	#$0028
	STA 	$27
	LDA 	$2D
	CMP 	$27
	ACC08
	BCC 	er01
PC61x:
	rts

R3431:	; $xxxx - $3431
	JSR 	R3503
	LDY 	#$01
	STA 	($2D),Y
	DEY 
	TXA 
	STA 	($2D),Y
	RTS 

PC5C:	; $xxxx - $343D
PC5D:	; dispose
	bit	runf
	bmi	?02
	jmp	vpme07
?02:	JSR 	R3511
?04:	JSR	R3527
	BEQ	?12 
	LDY 	#$00
	LDA 	($2D),Y
	CMP 	$21
	BNE	?08 
	INY 
	LDA 	($2D),Y
	CMP 	$22
	BNE	?08 
	LDA 	$21
	SEC 
	SBC 	$23
	STA 	$25
	LDA 	$22
	SBC 	$24
	STA 	$26
	LDY 	#$03
?06:	LDA 	($21),Y
	STA 	($25),Y
	DEY 
	BPL	?06 
	LDA 	$25
	STA 	$21
	LDA 	$26
	STA 	$22
	bra	?10
?08:	LDY 	#$00
	ACC16
	LDA 	($2D),Y
	SEC 
	SBC 	$23
	STA 	$25
	INY 
	ACC08
	JSR 	R3503
	CMP 	$26
	BNE 	?04 
	CPX 	$25
	BNE	?04 
?10:	LDY 	#$02
	ACC16CLC 
	LDA 	($21),Y
	ADC 	$23
	STA 	$23
	STA 	($21),Y
	LDY 	#$01
	LDA 	($21)
	STA 	($27)
	ACC08
	JSR 	R3431
	DEY 
	JSR 	R351E
	bra	?04
?12:	JSR 	R3503
	LDY 	#$00
	LDA 	($2D),Y
	CMP 	$33
	BNE 	?14 
	INY 
	LDA 	($2D),Y
	CMP 	$34
	BNE 	?14 
	ACC16
	LDA 	$33
	SEC 
	SBC 	$23
	STA 	$33
	lda	!MTPTR
	sta	$35
	ACC08
	JMP 	SK02
?14:	LDY 	#$00
	CPU16
	LDA 	($2D)
	SEC 
	SBC 	$23
	STA 	($27)
	STA 	$21
	TYA 
	STA 	($21),Y
	INY 
	INY 
	LDA 	$23
	STA 	($21),Y
	lda	!MTPTR
	sta	$35
	CPU08
	JMP 	SK02

R3503:	; $xxxx - $3503
	LDY 	#$02
	CLC 
	LDA 	$21
	ADC 	($21),Y
	TAX 
	INY 
	LDA 	$22
	ADC 	($21),Y
	RTS

R3511:	; $xxxx - $3511
	LDA 	$23
	LSR	a 
	ORA 	$24
	BNE 	?02 
	INC 	$23
?02:	ASL 	$23
	ROL 	$24
R351E:	; $xxxx - $351E
	ACC16
	lda	$35
	sta	!MTPTR
	lda	#MTPTR
	sta	$21
	ACC08
	;LDA 	#$35
	;STA $21
	;LDA #$00
	;STA $22
	RTS 

R3527:	; $xxxx - $3527
	LDA 	$21
	STA 	$27
	LDA 	$22
	STA 	$28
	LDY 	#$00
	LDA 	($21),Y
	TAX
	INY 
	LDA 	($21),Y
	STA 	$22
	STX 	$21
	ORA 	$21
	RTS 

PC5E:	; $1A54 - $1CDF
PC5F:
	ACC16
	ASL 	$23
	SEC
	LDA 	($2D)
	SBC 	$23
	STA 	$25
	INY 
	INY 
	SEC 
	LDA 	($2D),Y
	SBC 	$23
	STA 	$21
	ACC08
	JSR 	L1AFF
	LDA 	$2D
	CLC 
	ADC 	#$04
	STA 	$2D
	BCC 	?02 
	INC 	$2E
?02:	RTS

PC37:	; $1B1E - $1DA9 
	LDA 	#$08
	STA 	$23
	STY 	$24

PC6A:	; $1ACB - $1D56
PC6B:
	ACC16
	ASL 	$23
	LDA 	($2D)
	SEC 
	SBC 	$23
	STA 	$25
	LDA 	$2D
	inc	a
	inc	a
	SEC 
	SBC 	$23
	STA 	$2D
	STA 	$21
	ACC08
	
L1AFF:	; $1AFF - $1D8A
	LDY 	#$00
	DEC 	$24
	BMI 	?04 
?02:	LDA 	($25),Y
	STA 	($21),Y
	INY 
	BNE 	?02 
	INC 	$26
	INC 	$22
	BNE 	L1AFF 
?04:	CPY 	$23
	BEQ 	?06 
	LDA 	($25),Y
	STA 	($21),Y
	INY 
	BNE 	?04 
?06:	RTS 

PC62:	; $1AB6 - $1D41
PC63:
	ACC16
	ASL 	$23
	SEC
	LDA 	($2D)
	SBC 	$23
	STA 	($2D)
	ACC08
	rts

PC64:	; $2068 - $2A09
PC65:
	JSR 	L2095
?00:	LDA 	($25),Y
	CMP 	($21),Y
	BNE 	PC65b 
	ASL	a 
	BEQ 	?01 
	INY 
	CPY 	$23
	BNE 	?00 
?01:	
PC65a:	LDA 	#$01		; R2A1A
	bra	PC65c
PC65b:	lda	#0		; R2A1D
PC65c:	LDY 	#$02
	STA 	($2D),Y
	LDA 	#$00
	INY 
	STA 	($2D),Y
	LDA 	#$02
	jmp	L155E
	
PC66:	; $xxxx - $2A42
PC67:
	bit	runf
	bmi	?02
	jmp	vpme07
?02:	JSR 	R2A57
?04:	LDA 	($25),Y
	CMP 	($21),Y
	BMI 	PC65b 
	BNE 	PC65a 
	ASL	a 
	BEQ 	PC65a 
	INY 
	CPY 	$23
	BNE 	?04 
	BEQ 	PC65a 

PC68:	; $xxxx - $2A2D
PC69:
	bit	runf
	bmi	?02
	jmp	vpme07
?02:	JSR 	R2A57
?04:	LDA 	($21),Y	
	CMP 	($25),Y
	BMI 	PC65b 
	BNE 	PC65a 
	ASL	a 
	BEQ 	PC65a 
	INY 
	CPY 	$23
	BNE	?04 
	BEQ	PC65a 

R2A57:
L2095:	; $2095 - $2A57
	ACC16
	LDA 	($2D)
	STA 	$25
	INY
	iny
	LDA 	($2D),Y
	STA 	$21
	ACC08
	LDY 	#$00
	RTS 

PC6E:	; $0B48 - $0D4E
PC6F:
	JSR	L0B7F
	LDY 	#$00
	LDA 	($29),Y
	AND 	#$10
	BNE	?06 
	JSR	L0EA8
?02:	LDY 	#$00
	LDA 	($21),Y
	JSR 	L0EC4
	INC 	$21
	BNE 	?04 
	INC 	$22
?04:	JSR	L0B71
	BNE	?02 
	jsr	FCLRCH
	JMP	SK02
?06:
PC76:
PC77:
PC78:
PC79:
	JMP	vpme07

PC6Cx:	; $0983 - $0B94 
	jmp	SK04
	
PC6C:	; $0991 - $0B97
PC6D:	; 'reset' on disk
	JSR	L09C2
	LDA 	$3E
	BNE 	PC6Cx
	INC 	$BB		; skip '@'
	BNE 	?02 
	INC 	$BC
?02:	ldy 	$B7		; flength
	dey
	sty	$B7
	dey
	lda	#'R'		; read
	sta	[$BB],y
	;SEC 
	;SBC 	#$05
	;dec	a		; skip '@' ???
	;STA 	$B7
	;lda	#$C0
	;trb	$B9
	JSR 	FOPEN
	JSR 	L0A73
	LDA 	$3E
	BNE 	PC6Cx 
	LDA 	#$00
	TAY 
	STA 	($29),Y
	LDA 	$2D
	CLC 
	ADC 	#$02
	STA 	$2D
	BCC 	?04 
	INC 	$2E
?04:
PC70:	; $0B0C - $0D12
PC71:
	JSR 	L0B7F
	LDY 	#$00
	LDA 	($29),Y
	AND 	#$10
	BNE 	?10 
	JSR 	L0F11
?02:	JSR	L0F2B
	LDY 	#$00
	STA 	($21),Y
	INC 	$21
	BNE	?04 
	INC	$22
?04:	TAX 
	LDY 	#$00
	LDA 	($29),Y
	AND 	#$80
	BNE 	?06 
	JSR	L0B71
	BNE	?02 
	CPX	#$0D
	BNE	?06 
	LDA 	($29),Y
	ORA 	#$40
	STA 	($29),Y
?06:	JSR	FCLRCH
?08:	JMP	SK02
?10:	JMP	vpme07

L0B71:	; $0B71 - $0D77
	LDA 	$23
	SEC 
	SBC 	#$01
	STA 	$23
	BCS 	?02 
	DEC 	$24
?02:	ORA 	$24
	RTS 

L0B7F:	; $0B7F - $0D85
	ACC16
	LDA 	($2D),Y
	iny
	STA 	$29
	ASL 	$23
	SEC 
	LDA 	$29
	SBC 	$23
	STA 	$21
	LDA 	$23
	ACC08
	BNE 	?04
	INC 	$23
	LDA 	$21
	SEC 
	SBC 	#$02
	STA 	$21
	BCS 	?02 
	DEC 	$22
?02:	LDA 	#$00
	LDY 	#$01
	STA 	($21),Y
?04:	RTS 

PC18:	; $13FF - $168A
	; load string 'true ' or 'false'
	JSR	L1762
	ROR	$21		; CF = 1 if TRUE
	INDEX16
	ldx	#MFALSE		; false
	BCC	?02
	ldx	#MTRUE		; true
?02:	stx	$21
	INDEX08
	bra	L13E9

PC17:	; $13E6 - $1671
	JSR	L1762
L13E9:	; $13E9 - $1674
	LDY	#$00
?02:	INY 
	LDA	($21),Y
	BNE	?02 
	LDA	$23
	AND	$24
	EOR	#$FF
	BNE 	?04
	STY	$23
?04:	STY	$25
	bra	L16AA

PC72:	; $168E - $1919
PC73:
	LDA 	$24
	STA 	$26
	LDA 	$23
	STA 	$25
	JSR 	L1762
	LDA 	$25
	EOR 	#$01
	ROR	a 
	LDA 	$21
	SBC 	$25
	STA 	$21
	LDA 	$22
	SBC 	$26
	STA 	$22
L16AA:	; $16AA - $1935	
	LDX 	$25
	JSR	L0E69
	LDX 	$25
	LDA 	$23
	CMP 	$25
	BCS 	?02 
	TAX 
?02:	LDY 	#$00
	DEX 
	BMI 	?04 
	LDA 	($21),Y
	JSR 	L0EC4
	INC 	$21
	BNE 	?02 
	INC 	$22
	BNE 	?02 
?04:	JMP	FCLRCH

PC74:	; $1BC0 - $1E4B
PC75:
	JSR	L1B8B
	LDA 	$21
	SEC 
	SBC	#$04
	BCS	?02 
	DEC	$22
?02:	ASL 	$23
	ROL 	$24
	SEC 
	SBC 	$23
	STA 	$21
	LDA 	$22
	SBC 	$24
	STA 	$22
	LDY 	#$00
	LDA 	($21),Y
	STA 	$23
	INY 
	LDA 	($21),Y
	STA 	$24
	INY 
	LDA 	($21),Y
	LDY 	#$00
	JSR 	L1B93
	JMP	L1B45

; read string
PC7A:	; $16D0 - $195B
PC7B:
	JSR	L178B
	PHA 
	LDA 	$23
	EOR 	#$01
	ROR	a
	LDY 	#$02
	LDA 	($2D),Y
	SBC	$23
	STA 	$21
	INY 
	LDA 	($2D),Y
	SBC 	$24
	STA 	$22
	PLA 
?02:	CMP	#$20
	BEQ	?04 
	CMP	#$0D
	BEQ	?04 
	CMP	#$0A
	BNE	?06 
?04:	JSR	L0F2B
	bra	?02
?06:	LDY	#$00
	CMP	#$0D
	BEQ	?12 
	STA 	($21),Y
	INC 	$21
	BNE	?08 
	INC	$22
?08:	LDA	$23
	SEC 
	SBC	#$01
	STA	$23
	BCS	?09 
	DEC 	$24
?09:	ORA 	$24
	BEQ	?10 
	JSR	L0F2B
	bra	?06
?10:	JSR	L0F2B
	CMP	#$0D
	BNE	?10 
	BEQ	?14 
?12:	LDY	#$FF
	LDA	#$20
?13a:	INY 
	CPY	$23
	BEQ	?13 
	STA	($21),Y
	BNE	?13a
?13:	LDA	#$FF
	STA 	$23
	DEC 	$24
	BPL	?12 
	LDA	#$0D
?14:	JSR	L17B7
	JMP	SK04

L178B:	; $178B - $1A16
	JSR 	L17A3
	JSR	L0F11
	SEC 
	LDA 	$29
	SBC 	#$02
	STA 	$27
	LDA 	$2A
	SBC 	#$00
	STA 	$28
	LDY 	#$00
	LDA 	($27),Y
	RTS

PC7C:	; $203F - $2ABE
PC7D:	; execute function/procedure
	LDA 	$23
	ASL	a 
	TAX
	bit	runf
	bmi	?02
	jmp	(CFUNCT,X)	; compiling
?02:	jmp	(RFUNCT,X)	; running

PC7E:	; $1FEA - $2A6D
PC7F:	; change p-code pointer
	JSR 	L2027
	ACC16
	LDA 	($23)
	inc	a
	STA 	($23)
	ACC08
	xba
	EOR 	#$80
	ORA 	($23)
	BNE	?04 
	CLC 
	LDA	$2B
	ADC	#$03
	STA	$2B
	BCC	?04 
	INC	$2C
?04:	rts

PC3E:	; $xxxx - $3240 (CHAIN)
	jmp	vpme07

PC3F:	; $14A7 - $1732
	JSR 	L17AD
	DEY 
	bra	L148A

L17A3:	; $17A3 - $1A2E
	STZ 	$3E		; clear error
	ldy	#0
	JSR 	L17AD

L148A:	; $148A - $1715
	LDY 	#$00
	LDA 	($29)
	AND 	#$02
	BEQ 	L17B0 
	EOR 	($29)
	STA 	($29)
	JSR 	L0F11
?02:	JSR 	L0F2B
	CMP 	#$0A
	BEQ 	?02 
	jsr	L17B7
	JMP 	FCLRCH

L17AD:	; $17AD - $1A38
	LDA 	($2D),Y
	STA 	$29
	INY 
	LDA 	($2D),Y
	STA 	$2A
L17B0:
	RTS 

L17B7:	; $17B7 - $1A42
	; store char
	LDX 	#$00
	CMP 	#$0D
	BNE 	?02 
	LDA 	#$20
	LDX 	#$40
?02:	PHA 
	STX 	$27
	LDY 	#$00
	LDA 	($29)
	AND 	#$BF
	ORA 	$27
	STA 	($29)
	ACC16
	LDA 	$29
	dec	a
	dec	a
	STA 	$27
	ACC08
	PLA 
	STA 	($27)		; store char
	TYA 
	INY 
	STA 	($27),Y
	RTS 
	
;---------------------------------------------------------------------------
; I/O subsystem
;---------------------------------------------------------------------------

L0E91:	; $0E91 - $111C
	; check break from keyboard
	LDA 	$3B
	AND 	#$40
	BEQ 	?02		; no detect break 
	JSR 	CHKSTOP	
	bne	?02		; no break detected
	ldx	#$13		; break error
	jmp	vpmerr
?02:	lda	$42
	adc	#$05
	sta	$42
	rts

R0AE9:
L0942:	; $0942 - $0AE9
	; close all open files (10 files from #2 to #11)
	LDX 	#MAX2LF-6	; skip first 2 entry (#0 and #1)
?01:	LDA 	!MFILET+5,X	; file table
	BNE	?04 
?02:	DEX 
	DEX 
	BPL	?01
	RTS 
?04:	LDA	!MFILET+5,X
	STA 	$2A
	LDA	!MFILET+4,X
	sta	$29
	bit	runf
	bpl	?06
	cmp	$2F
	lda	$2A
	sbc	$30
	bcs	?02
	lda	$29
	cmp	$33
	lda	$2A
	sbc	$34
	bcc	?02
?06:	STZ 	MFILET+4,X
	STZ 	MFILET+5,X
	TXA 
	phx 
	LSR	a 
	ADC 	#$02		; skip file#0 and file #1
	STA 	$B8
	JSR 	L0A5B		; R0C61
	PLX
	bra	?02 

R0B28:	; $xxxx - $0B28
	; close all files in running mode
	LDX 	#$00
	STX 	$33
	STX 	$34
	DEX 
	STX 	$2F
	STX 	$30
	JSR 	R0AE9
	LDA 	#$01		; close #1 reserved to command channel
	JMP 	FCLOSE 

; CLOSE ???
L0A5B:	; $0A5B - $0C61
	; close
	LDY 	#$00
	LDA 	($29),Y
	AND 	#$08
	BEQ 	?02
	pha
	LDX 	$B8
	jsr	FSETOUT		; set file for output
	pla
	
	;;jsr	FCHROUT
	
	jsr	FCLRCH
?02:	LDA 	$B8		; close
	JMP 	FCLOSE

?20:	.DB	'close %bu', $0D

L0E7C:	; $0E7C - $1107
	; print string zero-terminated
	LDY 	#$00
?01:	LDA 	($21),Y
	BEQ 	?02 
	JSR 	FCHROUT
	INY 
	BNE 	?01 
?02:	RTS 

lprint:	; long print string zero-terminated
	LDY 	#$00
?01:	LDA 	[longp],Y
	BEQ 	?02 
	JSR 	FCHROUT
	INY 
	BNE 	?01 
?02:	RTS 

L0F9B:	; $0F9B - $1226
	LDA 	#$01
	STA 	$B8
	ACC16
	lda	#MSTDF1+2	; default file #1 (disk command channel)
	STA 	$29
	ACC08

L0E89:	; $0E89 - $1114
	; print CR
	PHA 
	LDA 	#$0D
	JSR 	FCHROUT
	PLA 
	RTS 

L0F2B:	; $0F2B - $11B6
	STY 	$27
	LDA 	$B8
	BNE 	?01 
	JSR 	L0E91		; R111C
	phx
	phy
	jsr	RDTIM
	STA 	$41
	ply
	plx
	JSR 	L0F73		; R11FE
	;JSR 	L2C5E		; R0DEF
	bra	?03
?01:	; $0F41 - $11CC
	LDY 	#$00
	STY 	$90
	LDA 	($29),Y
	AND 	#$80
	BNE 	?06
	LDA 	$3E		; current run-time error
	BNE 	?02	 
	JSR 	FCHRIN		; input byte
	STA 	$28
	LDA 	$90
	BNE 	?04 
?02:	LDA 	$28
?03:	LDY 	$27
	RTS 
?04:	CMP 	#$40		; end of file ?
	BNE 	?08
	LDA 	($29),Y
	ORA 	#$80
	STA 	($29),Y
	BNE 	?02 
?06:	LDX 	#$0F		; error: end of file
	bra	?10
?08:	ldx	#$11		; error: device read error
?10:	LDY 	$27
	bra	L0FAA
	
L0F25:	; $0F25 - $11B0
	ldx	#$0D		; error: file not open for reading
	bra	L0FAA
L0EBE:	; $0EBE - $1149
	ldx	#$0E		; error: file not open for writing
L0FAA:	; $0FAA - $1235
	bit 	$3B		; bit 7 = 1: no errors trap
	bmi	?04		; print error
	LDA 	$3E
	BNE	?02  
	STX 	$3E		; runtime error
?02:	RTS 
?04:	JMP 	vpmerr

R0F69:
L0CDE:	; $0CDE - $0F69
	; open file in internal table (24 bytes, 12 files)
	LDX 	#$00
	ACC16
?02:	LDA 	!MFILET,X	; logical file table (#0 and #1 permanent)
	BEQ 	?04		; free entry 
	INX
	INX
	CPX 	#MAX2LF		; max files * 2 (22)
	BNE	?02 
	ACC08
	LDX 	#$10		; error: no free i/o channels
	bra	L0FAA
?04:	LDA 	$29		; word
	STA 	!MFILET,X	; fill entry on table M2CDA
L0CFD:	; $0CFD - $0F88
	ACC08
	TXA 
	LSR	a		; file number 
	STA 	$B8
L0F10:	RTS 

L0F11:	; $0F11 - $119C
	LDY 	#$00
	LDA 	($29),Y
	AND 	#$20
	BNE 	L0F25 
	JSR 	L0D02
	LDX 	$B8
	BMI 	L0F25 
	BEQ 	L0F10 
	JMP 	FSETIN		; set file for input

L1762:	; $1762 - $19ED
	LDY 	#$00
	STY 	$3E
	ACC16
	LDA 	($2D),Y
	STA 	$23
	INY 
	INY 
	LDA 	($2D),Y
	STA 	$21
	INY 
	INY
	ACC08
	JSR 	L17AD
	LDA 	$2D
	CLC 
	ADC 	#$06
	STA 	$2D
	BCC 	?02 
	INC 	$2E
?02:	;;;JMP	L0EA8

L0EA8:	; $0EA8 - $1133
	LDY 	#$00
	LDA 	($29),Y
	AND 	#$30
	BEQ 	L0EBE 
	JSR 	L0D02
	LDX 	$B8
	BMI 	L0EBE 
	CMP 	#$01
	BEQ	L0F10 
	JMP 	FSETOUT		; set file for output

L1FC5:	; $1FC5
	ACC16
	LDA	($2D)
	STA	$21
	INY
	INY
	LDA	($2D),Y
	STA	$29
	ACC08
	bra	L0EA8

R0F8D:
L0D02:	; $0D02 - $0F8D
	; search file in internal table
	LDX 	#$FF
	STX 	$B8		; invalid file
	INX
	ACC16
?02:	LDA 	!MFILET,X	; scan logical file table
	CMP 	$29
	BEQ	L0CFD		; found
	INX
	INX
	CPX 	#MAX2LF		; max files * 2
	BNE	?02 
	ACC08
_?rs:	rts

L2CAA:	; $2CAA - $0E3B
	; send char to printer
	STA 	tmpa
	JSR 	CIOUT
	LDA 	tmpa
	CMP 	#$0D
	BNE 	_?rs 
	LDA 	autolf		; send LF if not zero
	BEQ 	_?rs		; auto line feed flag 
	LDA 	#$0A
	JMP 	CIOUT

L0D1C:	; $0D1C - $0FA7
	; print integer - $21-$22 = integer, $23 = size of the print field
	LDX 	#$00
	LDA 	$22		; $21-$22 = integer
	PHP
	bit	runf		; when compile print unsigned
	ACC16
	bpl	?02		; compiler: no 2's complement
	LDA 	$21		; $21-$22 = integer
	bpl	?02 
	eor	#$FFFF
	inc	a
	STA 	$21
	INX 
?02:	LDY 	#$00
	sec
?04:	INX 
	;SEC 
	LDA 	$21
	SBC	!MPOW10,y
	INY
	INY
	BCS 	?04
	ACC08
	JSR 	L0E69		; print blanks
	PLP
	BPL	?06
	bit	runf		; when compile print unsigned
	bpl	?06
	LDA 	#$2D
	JSR 	L0EC4		; print sign
?06:	SEC
	PHP
	LDY 	#$08
	ACC16
?08:	LDX 	#$2F
	sec
?10:	INX 
	;SEC 
	LDA 	$21
	SBC	!MPOW10-2,y
	STA 	$21
	BCS 	?10
	ACC08
	txa
	CMP 	#$30
	BNE 	?12 
	PLP
	BCS 	?14 
	PHP
?12:	JSR 	L0EC4		; print digit
	PLP
	clc
?14:	php	
	ACC16CLC
	LDA 	$21
	ADC	!MPOW10-2,y
	STA 	$21
	DEY
	DEY
	BNE 	?08
	ACC08
	plp
	LDA 	$21
	CLC 
	ADC 	#$30

L0EC4:	; $0EC4 - $114F
	; write char to text device
	PHP 
	sta	tmpwa 
	STY 	tmpy
	stx	tmpx
	LDY 	$B8
	CPY 	#$01
	BEQ	?03		; to command channel 
	LDY 	$BA
	CPY	#$03
	BEQ 	?03		; to screen 
	BCC	?03
	tay
	LDA 	($29)
	bit 	#$04
	BEQ 	?01		; no printer 
	tya 
	JSR 	L2CAA		; send to printer
	bra	?04
?01:	AND 	#$08
	TAY 
	lda	tmpwa 
	CPY 	#$00
	BNE 	?03 
	CMP 	#$0D
	BEQ 	?02 
	JSR 	CIOUT
	bra	?04
?02:	JSR 	CIOUT
	bra	?04
?03:	JSR 	FCHROUT
?04:	JSR 	L0E91
	ldx	tmpx
	LDY 	tmpy
	lda	tmpwa
	PLP 
_?rs1:	RTS 

L29B6:	; $29B6 - $2F98
	; print a blank or minus sign
	LDA	#$20
	BIT	$66
	BPL	L0EC4
	LDA	#$2D
	bra	L0EC4

L0E69:	; $0E69 - $10F4
	TXA 
	EOR 	#$FF
	SEC 
	ADC 	$23
	TAX 
?01:	DEX 
	BMI	_?rs1 
	LDA 	#$20
	JSR 	L0EC4
	bra	?01

L0A73:	; $0A73 - $0C79
	; handle disk error
	;LDX 	#$01		; file #1
	;JSR 	FSETIN		; channel command in input
	jsr	FCLRCH
	bit	pcdsk
	bpl	?rd		; compile/exec on real disk
	stz	$21		; no real disk error
	
	lda	#0		; no error
	bra	?rd2
	
?rd:	lda	tbnk		; destination buffer
	pha
	pea	#TXTBUF
	pea	#TBUFMAX-1	; size
	lda	#$0F		; command chnl
	pha
	CBMFSRD			; get error string
	phb
	lda	tbnk
	pha
	plb
	lda	!TXTBUF
	and	#$0F
	asl	a
	sta	$21
	asl	a
	asl	a
	adc	$21
	sta	$21
	lda	!TXTBUF+1
	plb
	and	#$0F
	adc	$21
	sta	$21
	beq	?rd2		; no error
	cmp	#20		; below 20 no disk error
	lda	#0
	bcc	?rd2
	lda	#MAXVPME	; disk error
?rd2:	sta	$3E
	
	;jsr	FCHRIN		; get error code
	;sta	$21
	;jsr	FCLRCH
	;LDA 	$21		; error code
	;STA 	$3E		; error code from disk
	
	BEQ 	_?rs1		; no disk error
	LDA 	$3B
	AND 	#$80
	BEQ 	_?rs1		; trap i/o error
	lda	$29		; save current file desc
	sta	fbufpt
	lda	$2A
	sta	fbufpt+1
	JSR 	L0F9B		; reset file #1 and print CR
	stz	$3B
	ldx	$3E		; error code
	cpx	#MAXVPME
	bcc	?er0		; no disk error
	lda	tbnk
	sta	longp+2		; error string from disk
	lda	#<TXTBUF
	sta	longp
	lda	#>TXTBUF
	sta	longp+1
	lda	$21
	sta	$3E		; disk error code
	bra	?er1
?er0:	jsr	vpmsrch		; search error string - store ptr in longp

	; now format and print error message
	
?er1:	ldy	$B7
	bne	?02a		; file name

	lda	longp+2		; param 3: error string pointer
	pha
	pei	(longp)
	lda	$3E		; param 2: error code
	pha
	lda	#^STRFMT1A	; param 1: format string
	pha
	pea	#STRFMT1A
	lda	#$08		; param 0: number of total bytes
	bra	?pr

	;stz	!MTMPB0
	;ACC16
	;lda	$BB		; set an empty string if no file name
	;bne	?02a
	;lda	#MTMPB0
	;sta	$BB
?02a:	;ACC08

	lda	$BD		; param 4: file name pointer
	pha
	pei	($BB)
	lda	longp+2		; param 3: error string pointer
	pha
	pei	(longp)
	lda	$3E		; param 2: error code
	pha
	lda	#^STRFMT1	; param 1: format string
	pha
	pea	#STRFMT1
	lda	#$0B		; param 0: number of total bytes
?pr:	pha
	BPRINTF
	;;JSR 	L0E89
	JMP 	vpmerr2

L09C2:	; $09C2 - $0BC8
	; prepare for open a disk file
	STZ 	$3E		; clear runtime error
	ACC16
	LDA 	($2D)
	STA 	$21
	INY 
	INY 
	LDA 	($2D),Y
	SEC 
	SBC 	#$0003
	STA 	($2D),Y
	STA 	$29 
	dey
	STA 	($29),Y
	ACC08
	JSR 	L0D02		; search file
	LDA 	$B8
	BMI 	?02		; no file in internal table 
	JSR 	L0A5B		; close file
	bra	?04
?02:	JSR 	L0CDE		; open file in internal table
?04:	LDA 	$3E
	beq	?044
	rts
	;BNE 	?14		; exit if any error 
?044:	LDA 	$21
	ORA 	$22
	;;BNE 	?06		; file name was specified
	beq 	?05		; file name was not specified

	lda	($21)
	cmp	#'@'
	bne	?04a
	inc	$21
	bne	?04a
	inc	$22
?04a:	ldy	#1
	lda	($21),y
	cmp	#':'
	beq	?06		; drive present 'x:'
	dey
?04b:	lda	($21),y
	sta	MTMPB0,y
	beq	?04c
	cmp	#' '
	beq	?04c
	iny
	cpy	#17
	bcc	?04b
	lda	#0
	sta	MTMPB0-1,y
?04c:	lda	#'0'
	sta	!MTMPB0-2
	lda	#':'
	sta	!MTMPB0-1	
	LDA 	#<MTMPW1	; local buffer file name
	STA 	$21
	LDA 	#>MTMPW1
	STA 	$22
	bra	?06
	
?05:	lda	#<MTMPNAM	; setup temp. file
	sta	$21
	lda	#>MTMPNAM	; temp. file name '0:PCODEV01.XTN'
	sta	$22
	lda	$B8		; #file number 2..11
	clc
	adc	#$2E		; '0'..'9'
	sta	!MTMPNAM+$0D	; N = '0'..'9'
?06:	; compiler bug -- store one more '@' in front
	; avoid this - skip '@' if one at beginning
	lda	($21)
	cmp	#'@'
	bne	?07
	inc	$21
	bne	?07
	inc	$22
?07:	LDA 	#<GFNAME	; global buffer file name
	STA 	$BB
	LDA 	#>GFNAME
	STA 	$BC
	lda	tbnk		; text bank
	sta	$BD		; bank
	LDY 	#$00
	LDA 	#$40		; put '@' - replace file on disk if write
	STA 	[$BB],Y
?08:	LDA 	($21),Y
	INY
	CMP 	#'a'
	BCC 	?10
	CMP 	#'z'+1
	BCS 	?10
	and	#$DF
?10:	CMP 	#$00		; #0 is string terminator
	BEQ 	?12
	CMP 	#$20
	BEQ 	?12		; blank is a string terminator 
	STA 	[$BB],Y
	CPY 	#MAXFNLEN-1	; one more room for '@'
	bcc 	?08
	INY			; trunc file name if exceed
?12:	lda	#','		; put final ',s,w'
	sta	[$BB],y
	iny
	lda	#'S'
	sta	[$BB],y
	iny
	lda	#','
	sta	[$BB],y
	iny
	lda	#'W'
	sta	[$BB],y
	iny	
	lda	#0
	STA 	[$BB],Y		; store terminator	
	STY 	$B7		; filename lenght
	LDA 	$B8
	;and	#$3F
	;ora	#$80
	STA 	$B9		; secondary address = file number
	LDA 	#$08		; virtual iec disk #number
	STA 	$BA
?14:	RTS

L0F73:	; $0F73 - $11FE
	; get byte from input buffer -- with boundary check
	LDY	inqidx
	CPY	inqcnt
	BNE	?04 
	LDY	#$00
	STY 	inqidx
?02:	JSR	FCHRIN
	STA	!MINBUF,Y
	INY
	cpy	#QINSIZ		; check boundary
	bcc	?03		; room available
	lda	#$0D		; terminate input
	STA	!MINBUF-1,Y
	;sta	$ff00-1,y
?03:	CMP	#$0D
	BNE	?02
	STY	inqcnt
	JSR	FCHROUT
	LDY	inqidx
?04:	INC	inqidx
	LDA	!MINBUF,Y
	RTS 

;---------------------------------------------------------------------------
; external function's used by compiler
;---------------------------------------------------------------------------

L084E:	; $1C33 - ($084E)
	; evaluate floating point constant
	.GLOBAL L084E
	ACC16
	SEC
	LDA 	($2D),Y
	SBC	#$0050
	STA	$7A
	ACC08
	JSR	XBCF3P
	TAX			; X = 0 if all ok
	ACC16
	LDY	#$02
	LDA	($2D),Y
	dec	a
	dec	a
	STA	$27
	INY
	iny
	LDA	($2D),Y
	dec	a
	dec	a
	STA	$23
	INY
	iny
	LDA	($2D),Y
	dec	a
	dec	a
	STA	$25
	iny
	ACC08
	LDA	#$00
	STA	($2D),Y
	CPX	#$00
	BNE	?16
	LDA	#$01
	STA	($2D),Y
?16:	DEY
	STA	($2D),Y
	ACC16
	lda	!FAC1TMP
	STA	($25)
	lda	!FAC1TMP+2
	STA	($27)
	ACC08
	lda	#$00
	xba
	lda	!FAC1TMP+4	
	ACC16CLC
	STA	($23)
	LDA	$2D
	ADC	#$0006
	STA	$2D
	ACC08
	RTS

L0851:	; $1D1C ($0851)
	; search reserved words
	.EXTERN PCRSWD
	.GLOBAL L0851
	SEC
	ACC16
	LDA	($2D)
	SBC	#$0008
	STA	$23
	ACC08
	LDA	#$FF
	STA	$21
	LDX	#$00
?02:	LDY	#$00
	INC	$21
?04:	LDA	($23),Y
	CMP	>PCRSWD,X
	BNE	?10
	INY
	CMP	#$20
	BEQ	?06
	INX
?06:	CPY	#$08
	BNE	?04
	LDA	$21
?08:	LDY	#$00
	STA	($2D)
	TYA
	INY
	STA	($2D),Y
	RTS
?10:	LDA	>PCRSWD,X
	INX
	CMP	#$20
	BNE	?10
	LDA	>PCRSWD,X
	BNE	?02
	LDA	#$27
	BNE	?08

L083C:	; $1E16 ($083C)
	; load an error message in compile mode
	.EXTERN PCERRS
	.GLOBAL L083C
	ACC16
	lda	($2D)
	sec
	sbc	#$0080
	sta	$21
	ACC08
	ldy	#$02
	lda	($2D),y		; error code
	tay			; Y = error code
	lda	#$80
	sta	pcterr		; set error flag
	ldx	#0		; index
	INDEX16
	tya
	beq	?04		; error code = 0 should not occur
	bne	?02
?01:	tax
	tay
	beq	?04
?02:	lda	>PCERRS,x	; offset of error string's
	beq	?01		; end of strings table
	inx
	cmp	#$0D
	bne	?02
	dey
	bne	?02
?04:	lda	>PCERRS,x	; here Y = 0 at first time
	inx
	sta	($21),y
	iny
	cmp	#$0D
	bne	?04		; until carriage return
	dey
	lda	#$24		; change CR
	sta	($21),y
	CPU16
	lda	$2D
	adc	#$0004
	sta	$2D
	CPU08
	rts

L0836:	; $1DC9 ($0836)
	; search standard procedure/function/identifier
	.EXTERN PCSFADDR
	.GLOBAL L0836
	ACC16
	LDA	#PCSFADDR
	sta	$23
	bra	L1D79 

L084B:	; $1D63 ($084B)
	; search user procedure/function/identifier
	.GLOBAL L084B
	ACC16
	LDA	($2D)
	STA	$23
	LDA	$2D
	inc	a
	inc	a
	STA	$2D
L1D79:
	LDA	($2D)
	SEC
	SBC	#$0008
	STA	$21
?02:	LDA	$23
	BEQ	?08
	SEC
	SBC	#$0010
	sta	$27
	ACC08
	LDY	#$00
?04:	LDA	($21),Y
	CMP	($27),Y
	BNE	?06
	INY
	CPY	#$08
	BNE	?04
	ACC16
	LDA	$23
	bra	?08
?06:	LDY	#$0E
	ACC16
	LDA	($27),Y
	STA	$23
	BNE	?02
?08:	STA	($2D)
	ACC08
L1E79x:	
	RTS

L083F:	; $1E79 ($083F)
	.GLOBAL L083F
	LDY	#$00
	LDA	($0F)
	BEQ	L1E79x
	ACC16
	LDA	($1B)
	STA	$29
	ACC08
	LDA	($0D)
	BEQ	?02
	ACC16
	LDA	($19)
	STA	$29
	ACC08
?02:	LDA	($29)
	AND	#$80
	BEQ	?04
	jmp	?10
?04:	ACC16
	LDA	$29
	dec	a
	dec	a
	STA	$21
	ACC08
	LDA	($21)
	STA	($0F)
	JSR	L0F11
?05:	JSR	L0F2B
	CMP	#$0A
	BEQ	?05
	STA	($21)
	JSR	FCLRCH
	LDA	($0F)
	CMP	#$0D
	BNE	?06
?05a:	LDA	#$20
	STA	($0F)
	CPU16
	LDA	($13)		; line number?
	inc	a
	STA	($13)

	;ldx	srcdsk
	;cpx	#$08
	;beq	?05b
	;lda	psrline
	;STA	($13)	

?05b:	tya
	STA	($11)
	CPU08
	LDA	#$01
	STA	($0B)
	LDA	($07)
	BEQ	?06
	ACC16
	LDA	($17)
	STA	$29
	ACC08
	JSR	L0EA8
	LDA	#$0D
	JSR	L0EC4
	LDY	#$00
	ACC16
	LDA	($13)
	STA	$21
	ACC08
	LDA	#$05		; line number 4 chars
	STA	$23
	JSR	L0D1C		; print line number
	JSR	FCLRCH
?06:	LDY	#$00
	LDA	($07)
	BEQ	?08
	ACC16
	LDA	($17)
	STA	$29
	ACC08
	JSR	L0EA8
	LDY	#$00
	LDA	($0F)
	JSR	L0EC4
	TAX
	LDA	($11)
	CMP	#$64
	BCS	?08
	inc	a
	STA	($11)
	TAY
	TXA
	STA	($15),Y
	JSR	FCLRCH
?08:	RTS
?10:	LDY	#$00
	LDA	($0D)
	BEQ	?12
	TYA 
	STA	($0D)
	bra	?05a
?12:	STA	($0F)
	LDA 	#$01
	STA 	($09)
	RTS

L0842:	; $1F4C ($0842)
	; setup group of 11 pointer from $07-$08 to $1B-$1C 
	.GLOBAL L0842
	phx
	LDY	#$00
	tyx
	ACC16
?02:	LDA	($2D),Y
	dec	a
	dec	a
	STA	<$07,x
	inx
	inx
	iny
	iny
	cpy	#$16
	bne	?02
	clc
	lda	$2D
	adc	#$0016
	sta	$2D
	sec
	lda	$15
	sbc	#$0063
	sta	$15
	ACC08
	plx
	rts

L0845:	; $1DD3 ($0845)
	; setup pointer to standard basic type records
	.EXTERN PCTYPEREC
	.GLOBAL L0845	
	LDX	#$00
	ACC16
?02:	LDA	($2D)
	dec	a
	dec	a
	STA	$27
	LDA	>PCTYPEREC,X
	sta	($27)
	lda	$2D
	inc	a
	inc	a
	sta	$2D
	inx
	inx
	cpx	#$14
	bne	?02
	ACC08
	rts

L0857:	; $1C2D ($0857)
	.GLOBAL L0857, L0854
	LDA 	#<MINBUF+$50	; buffer 0250?
	LDX	#>MINBUF+$50
	;lda	#$00
	;ldx	#$02
	bra	L1C14

L0854:	; $1BF1 ($0854)
	LDA	defprn		; open file for printer
	STA	$BA
	LDA	#$02
	STA	$B8
	LDA	#$00
	STA	$B9
	STA	$B7
	JSR	FOPEN
	LDA	$2D
	CLC	
	ADC	#$02
	STA	$2D
	BCC	?02
	INC	$2E
?02:	LDA	!MFILET+4	; default printer file descriptor
	LDX	!MFILET+5
L1C14:	; $1C14
	xba
	txa			; high byte
	xba
	CPU16
	tax
	LDA	($2D)
	dec	a
	dec	a
	STA	$27
	TXA
	STA	($27)
	CPU08
	bra	L1FDB

;---------------------------------------------------------------------------
; function's in 'compile' mode
;---------------------------------------------------------------------------

CF00:	; $1FAE
	LDA	($2D)
	AND	#$7F
	STA	($2D)
	TYA
	INY
	STA	($2D),Y
CF08:	; $1FB8
	RTS

; procedure wrhexb(n: integer) 
RF22:
	lda	#1
	ldx	#0
	jsr	PCE0		; set text to std. 'output'
	ldy	#2		; swap text var with integer 	
	CPU16
	lda	($2D)
	tax
	lda	($2D),y
	sta	($2D)
	txa	
	sta	($2D),y
	CPU08
	ldy	#0

; procedure fwrhexb(f: text, n: integer) 
RF07:
	JSR	L1FC5
	LDA	$21
	jsr	R353E
	bra	CF01x

; procedure wrhexw(n: integer) 
RF21:
	lda	#1
	ldx	#0
	jsr	PCE0		; set text to std. 'output'
	ldy	#2		; swap text var with integer 	
	CPU16
	lda	($2D)
	tax
	lda	($2D),y
	sta	($2D)
	txa	
	sta	($2D),y
	CPU08
	ldy	#0
	
; procedure fwrhexw(f: text, n: integer) 
RF06:
CF01:	; $1FB9
	; print hex	
	JSR	L1FC5
	JSR	L0D9B
CF01x:
	JSR	FCLRCH
	lda	#$04

L1FE0:	; $1FE0
	CLC
	ADC	$2D
	STA	$2D
	BCC	?02
	INC	$2E
?02:	RTS

L1FDB:	; $1FDB
	LDA	#$02
	bra	L1FE0

CF03:	; $1F7A
	INY
	LDA	($2D),Y
	BNE	?04
	DEY
	LDA	($2D),Y
	BEQ	L1FDB
	CMP	#$10
	BCS	?04
	TAX
	LDY	#$02
	LDA	($2D),Y
	STA	$27
	INY	
	LDA 	($2D),Y
?02:	ASL	$27
	ROL	a
	DEX
	BNE	?02
	STA	($2D),Y
	DEY
	LDA	$27
	STA	($2D),Y
	bra	L1FDB
?04:	LDY	#$02
	LDA	#$00
	STA	($2D),Y
	INY
	STA	($2D),Y
	bra	L1FDB

CF02:
CF04:
CF05:
CF06:
CF07:
	jmp	vpme07

L0D9B:	; $0D9B
	; print hex $21-$22
	LDA	$22
	JSR	R353E
	LDA	$21
	
R353E:
?10:	PHA 
	LSR	a
	LSR	a
	LSR	a
	LSR	a
	JSR	?20
	TAX
	PLA
	AND	#$0F
	JSR	?20
	PHA
	TXA
	JSR	FCHROUT
	PLA
	JMP	FCHROUT
?20:	CLC
	ADC	#$F6
	BCC	?30
	ADC	#$06
?30:	ADC	#$3A
	RTS

;---------------------------------------------------------------------------
; function's in 'run' mode
;---------------------------------------------------------------------------

; function peekb(address: integer): $00..$FF
RF00:
	ACC16
	lda	($2D)
	sta	$27
	ACC08
	tya
	iny
	sta	($2D),y
	lda	($27)
	sta	($2D)
	rts

; function peekw(address: integer): integer
RF01:
	ACC16
	lda	($2D)
	sta	$27
	lda	($27)
	sta	($2D)
	ACC08
	rts

; function peekbz(address: $00..$FF): $00..$FF
RF02:
	lda	($2D)
	tax
	lda	<$00,x
	sta	($2D)
	tya
	iny
	sta	($2D),y
	rts

; function peekwz(address: $00..$FF): integer
RF03:
	lda	($2D)
	tax
	ACC16
	lda	<$00,x	
	sta	($2D)
	ACC08
	rts

; function odd(n: integer): boolean
RF04:
	lda	#$01
	and	($2D)
	sta	($2D)
	
; function chr(n:integer): char
; function asc(c:char): integer
RF05:
	tya
	iny
	sta	($2D),y
	rts

; function sin(x: real): real
RF08:
	lda	#<XE26B
	ldy	#>XE26B
	bra	_math
	
_math:
	sta	$27
	sty	$28
	lda	$2D
	ldy	$2E
	jsr	XBBA2
	jsr	_mathj
	ldx	$2D
	ldy	$2E
	jmp	XBBD4
_mathj:
	jmp	(CBMP0+$0027)

; function cos(x: real): real
RF09:
	lda	#<XE264
	ldy	#>XE264
	bra	_math

; function cos(x: real): real
RF0A:
	lda	#<XE2B4
	ldy	#>XE2B4
	bra	_math

; function arctan(x: real): real
RF0B:
	lda	#<XE30E
	ldy	#>XE30E
	bra	_math

; function exp(x: real): real
RF0C:
	lda	#<XBFED
	ldy	#>XBFED
	bra	_math

; function ln(x: real): real
RF0D:
	lda	#<XB9EA
	ldy	#>XB9EA
	bra	_math

; function sqrt(x: real): real
RF0E:
	lda	#<XBF71
	ldy	#>XBF71
	bra	_math

; function raisexy(x,y: real): real
RF0F:
	lda	$2D
	ldy	$2E
	clc
	adc	#$06
	bcc	?02
	iny
?02:	jsr	XBA8C		; move x to FAC #2
	lda	$2D
	ldy	$2E
	jsr	XBBA2		; move y to FAC #1
	jsr	XBF7B		; compute x^y
	lda	$2D
	ldy	$2E
	clc
	adc	#$06
	bcc	?04
	iny
?04:	sta	$2D
	sty	$2E
	tax
	jmp	XBBD4

; function nroot(x: real; n: integer): real
RF10:
	lda	($2D)
	tax
	iny
	lda	($2D),y
	sta	$62
	sta	$21
	stx	$63
	bpl	?02
	lda	#$00
	sec
	sbc	$63
	sta	$63
	lda	#$00
	sbc	$62
	sta	$62
?02:	ldx	#$90
	sec
	jsr	XBC49		; convert integer to float
	lda	$21
	sta	$66
	lda	#<XB9BC		; move costant 1.0 to FAC #2	
	ldy	#>XB9BC
	ldx	#^RF10
	jsr	XBB0F		; and compute 1/n
	jsr	XBBC7		; round and move to FAC1TMP
	lda	$2D
	ldy	$2E
	clc
	adc	#$02
	bcc	?04
	iny
?04:	sta	$2D
	sty	$2E
	jsr	XBA8C		; move x to FAC #2
	lda	#<FAC1TMP
	ldy	#>FAC1TMP
	jsr	XBBA2T		; move 1/n to FAC #1
	jsr	XBF7B		; compute x^(1/n)
	ldx	$2D
	ldy	$2E
	jmp	XBBD4

; procedure swapw(var n,m: integer)
RF11:
	ldy	#$02	
	CPU16
	lda	($2D)
	dec	a
	dec	a
	sta	$25		; pointer to m
	lda	($2D),y
	dec	a
	dec	a
	sta	$27		; pointer to n
	lda	($25)
	tax
	lda	($27)
	sta	($25)
	txa
	sta	($27)
	CPU08
	jmp	SK04

; procedure passign(var p: pointer; adr:integer)
RF12:
	ldy	#$02
	ACC16
	lda	($2D),y		; pointer to p
	dec	a
	dec	a
	sta	$27
	lda	($2D)		; load adr
	sta	($27)		; assign to p
	ACC08
	jmp	SK04

; function trunc(x: real): integer
RF13:
	lda	$2D
	ldy	$2E
	jsr	XBBA2
RF13x:
	lda	$61
	beq	?08		; zero
	bpl	?08		; less than 1
	sec
	sbc	#$90
	bpl	?10		; integer overflow
	tax
?02:	lsr	$62
	ror	$63
	inx
	bne	?02
?04:	lda	$66
	bpl	?06
	lda	#$00
	sec
	sbc	$63
	sta	$63
	lda	#$00
	sbc	$62
	sta	$62
?06:	ldy	#$04
	ACC16
	lda	$62
	xba
	sta	($2D),y
	ACC08
	jmp	SK04
?08:	stz	$62
	stz	$63
	bra	?06
?10:	ldx	#$03		; integer overflow
	jmp	vpmerr

; function round(x: real): integer
RF14:
	lda	$2D
	ldy	$2E
	jsr	XBBA2
	lda	#<FCON05	; float 0.5
	ldy	#>FCON05
	ldx	$66
	bpl	?02		; add 0.5
	lda	#<XB9E0		; float -0.5
	ldy	#>XB9E0
?02:	jsr	XB867		; add =/- 0.5
	bra	RF13x		; and trunc

; function random: integer
RF15:
	jsr	decstk		; decrement stack
	lda	$41
	asl	a
	adc	#$00
	eor	$41
	lsr	a
	bcc	?02
	ora	#$80
?02:	inc	$42
	adc	$42
	sta	$41
	bvc	?04
	inc	$42
?04:	sta	($2D)
	tya
	iny
	sta	($2D),y
	rts

; procedure iotrap(boolean)
RF16:
	lda	($2D)
	php
	lda	prtrap
	ora	#$80
	plp
	bne	?02
	eor	#$80
?02:	sta	prtrap
	jmp	SK02

; procedure breaks(boolean)
RF17:
	lda	($2D)
	php
	lda	prtrap
	ora	#$40
	plp
	bne	?02
	eor	#$40
?02:	sta	prtrap
	jmp	SK02

; function ioerror: integer
RF18:
	jsr	decstk		; decrement stack
	lda	prterr
RF18x:
	sta	($2D)
	tya
	iny
	sta	($2D),y
	rts
	
; function getkey: char
RF19:
	jsr	decstk		; decrement stack
	jsr	FGETIN
	bra	RF18x

; function rdhex: integer;
RF20:	
	lda	#0
	tax
	jsr	PCE0		; set text to std. 'input'
	
; function frdhex(file: text): integer;
RF1A:	
	jsr	L178B
	jsr	R10A6
	bcc	?02
	ldx	#$02
	jsr	L0FAA
?02:	jsr	L17B7
	ldy	#1
	lda	$21
	sta	($2D)
	lda	$22
	sta	($2D),y
	jmp	FCLRCH
	
R10A6:
	ldx	#0
	stx	$21
	stx	$22
	cmp	#$20
	beq	?02
	cmp	#$0D
	beq	?02
	cmp	#$0A
	bne	?04
?02:	jsr	L0F2B
?04:	tax
	jsr	R10DA
	bcs	?10
?06:	ldy	#$04
?08:	asl	$21
	rol	$22
	dey
	bne	?08
	ora	$21
	sta	$21
	jsr	L0F2B
	tax
	jsr	R10DA
	bcc	?06
	clc
?10:	txa
	rts
	
R10DA:
	sec
	sbc	#$30
	bcc	?02
	cmp	#$0A
	bcc	?04
	sec
	sbc	#$07
	bcc	?02
	cmp	#$10
	bcc	?04
	sec
	sbc	#$20
	cmp	#$10
	rts
?02:	sec
?04:	rts

; function andw(a,b: integer): integer
RF1B:
	ldy	#$02
	ACC16
	lda	($2D)		; a
	and	($2D),y		; and b
	sta	($2D),y		; store in b
	ACC08
	jmp	SK02

; function orw(a,b: integer): integer
RF1C:
	ldy	#$02
	ACC16
	lda	($2D)		; a
	ora	($2D),y		; or b
	sta	($2D),y		; store in b
	ACC08
	jmp	SK02

; function xorw(a,b: integer): integer
RF1D:
	ldy	#$02
	ACC16
	lda	($2D)		; a
	eor	($2D),y		; xor b
	sta	($2D),y		; store in b
	ACC08
	jmp	SK02
	
; function notw(a: integer): integer
RF1E:
	ACC16
	lda	($2D)		; a
	eor	#$FFFF
	sta	($2D)
	ACC08
	rts
	
; function negw(a: integer): integer
RF1F:
	ACC16
	lda	($2D)		; a
	eor	#$FFFF
	inc	a
	sta	($2D)
	ACC08
	rts	

; function lpeekb(bank: $00..$FF; address: integer): $00..$FF
RF23:
	ACC16
	lda	($2D)
	sta	longp
	ACC08
	tya
	ldy	#3
	sta	($2D),y
	dey
	lda	($2D),y
	sta	longp+2
	lda	[longp]
	sta	($2D),y
	jmp	SK02

; function lpeekw(bank: $00..$FF; address: integer): integer
RF24:
	ACC16
	lda	($2D)
	sta	longp
	ACC08
	ldy	#2
	lda	($2D),y
	sta	longp+2
	ACC16
	lda	[longp]
	sta	($2D),y	
	ACC08
	jmp	SK02

; procedure pokeb(address, val: integer)
RF25:
	ldy	#2
	ACC16
	lda	($2D),y
	sta	$27
	ACC08
	lda	($2D)
	sta	($27)
	jmp	SK04
	
; procedure pokew(address, val: integer)
RF26:
	ldy	#2
	ACC16
	lda	($2D),y
	sta	$27
	lda	($2D)
	sta	($27)
	ACC08
	jmp	SK04

; procedure pokebz(zp, val: integer)
RF27:
	ldy	#2
	lda	($2D),y
	tax
	lda	($2D)
	sta	<$00,x
	jmp	SK04

; procedure pokewz(zp, val: integer)
RF28:
	ldy	#2
	lda	($2D),y
	tax
	ACC16
	lda	($2D)
	sta	<$00,x
	ACC08
	jmp	SK04

; procedure lpokeb(bank, address, val: integer)
RF29:
	ldy	#2
	ACC16
	lda	($2D),y
	sta	longp
	ACC08
	ldy	#4
	lda	($2D),y
	sta	longp+2
	lda	($2D)
	sta	[longp]
	bra	RF2Ax
	
; procedure lpokew(bank, address, val: integer)
RF2A:
	ldy	#2
	ACC16
	lda	($2D),y
	sta	longp
	ACC08
	ldy	#4
	lda	($2D),y
	sta	longp+2
	ACC16
	lda	($2D)
	sta	[longp]
RF2Ax:	ACC16CLC
	lda	$2D
	adc	#$0006
	sta	$2D
	ACC08
	rts

; function shl(val, shift: integer): integer
RF2B:
	iny
	lda	($2D),y
	bmi	RF2Bz
	bne	RF2Bx
	dey
	lda	($2D),y
	beq	RF2By
R1EE6:	cmp	#$10
	bcs	RF2Bx
	tax
	ldy	#2
	ACC16
	lda	($2D),y
?02:	asl	a
	dex
	bne	?02
	sta	($2D),y
	ACC08
	jmp	SK02

RF2Bx:	ldy	#2
	lda	#0
	sta	($2D),y
	iny
	sta	($2D),y
RF2By:	jmp	SK02

RF2Bz:	eor	#$FF
	bne	RF2Bx
	dey
	sec
	sbc	($2D),y
	bcc	R1F1C
R1F3C:	eor	#$FF
	bne	RF2Bx
	dey
	sec
	sbc	($2D),y
	bra	R1EE6

; function shr(val, shift: integer): integer
RF2C:
	iny
	lda	($2D),y
	bmi	R1F3C
	bne	RF2Bx
	dey
	lda	($2D),y
	beq	RF2By
R1F1C:	cmp	#$10
	bcs	RF2Bx
	tax
	ldy	#2
	ACC16
	lda	($2D),y
?02:	lsr	a
	dex
	bne	?02
	sta	($2D),y
	ACC08
	jmp	SK02

; function exp10(x: real): real
RF2D:
	lda	#<FCON10
	ldy	#>FCON10
	jsr	XBA8CK		; move float 10 to FAC #2
	lda	$2D
	ldy	$2E
	jsr	XBBA2		; move x to FAC #1
	jsr	XBF7B		; compute 10^x
	ldx	$2D
	ldy	$2E
	jmp	XBBD4

; function log(x:real):real
RF2E:
	lda	$2D
	ldy	$2E
	jsr	XBBA2		; move x to FAC #1
	jsr	XB9EA		; compute ln(x)
	jsr	XBC0C		; round FAC #1 and move to FAC #2
	lda	#<XLN10
	ldy	#>XLN10
	jsr	XBBA2K		; move ln(10) to FAC #1
	jsr	XBB12		; compute ln(x)/ln(10)
	ldx	$2D
	ldy	$2E
	jmp	XBBD4

;function nraise(x: real; n: integer): real
RF2F:
	stz	$23
	ldx	#$FF
	ACC16
	lda	($2D)
	sta	$21
	lda	$2D
	inc	a
	inc	a
	sta	$2D
	lda	$21
	bpl	?02
	tya
	sec
	sbc	$21
	sta	$21
	stx	$23
?02:	beq	?20		; if n = 0 return 1
	dec	a
	sta	$21		; counter
	ACC08
	php
	lda	$2D
	ldy	$2E
	jsr	XBBA2		; move x to FAC #1
	plp
	beq	?14		; if n = 1 return x, if n = -1 return 1/x
?06:	jsr	XBC0C		; round FAC #1 and move to FAC #2
	lda	$2D
	ldy	$2E
	ldx	vbnk
	jsr	XBA28		; x*x
	ACC16
	dec	$21
	ACC08
	bne	?06
?14:	bit	$23
	bpl	?22		; return value
	lda	#<XB9BC		; compute 1/x
	ldy	#>XB9BC
	ldx	#^RF2F
	jsr	XBB0F
	bra	?22
?20:	ACC08			; return 1.0
	lda	#$81
	sta	$61
	stz	$62
	stz	$63
	stz	$64
	stz	$65
	stz	$66
?22:	ldx	$2D
	ldy	$2E
	jmp	XBBD4

; pcmdlin(var p)	
RF30:
	ACC16CLC
	lda	($2D)		; pointer to p
	dec	a
	dec	a
	sta	$27
	lda	cmdlin		; load adr
	adc	#128
	sta	($27)		; assign to p
	ACC08
	jmp	SK02
	
;---------------------------------------------------------------------------
; address table's
;---------------------------------------------------------------------------

; function's table for p-code tokens $00..$7F
PCODET1:
	.DW	PC00, PC01, PC02, PC03, PC04, PC05, PC06, PC07
	.DW	PC08, PC09, PC0A, PC0B, PC0C, PC0D, PC0E, PC0F
	.DW	PC10, PC11, PC12, PC13, PC14, PC15, PC16, PC17
	.DW	PC18, PC19, PC1A, PC1B, PC1C, PC1D, PC1E, PC1F
	.DW	PC20, PC21, PC22, PC23, PC24, PC25, PC26, PC27
	.DW	PC28, PC29, PC2A, PC2B, PC2C, PC2D, PC2E, PC2F
	.DW	PC30, PC31, PC32, PC33, PC34, PC35, PC36, PC37
	.DW	PC38, PC39, PC3A, PC3B, PC3C, PC3D, PC3E, PC3F
	.DW	PC40, PC41, PC42, PC43, PC44, PC45, PC46, PC47
	.DW	PC48, PC49, PC4A, PC4B, PC4C, PC4D, PC4E, PC4F
	.DW	PC50, PC51, PC52, PC53, PC54, PC55, PC56, PC57
	.DW	PC58, PC59, PC5A, PC5B, PC5C, PC5D, PC5E, PC5F
	.DW	PC60, PC61, PC62, PC63, PC64, PC65, PC66, PC67
	.DW	PC68, PC69, PC6A, PC6B, PC6C, PC6D, PC6E, PC6F
	.DW	PC70, PC71, PC72, PC73, PC74, PC75, PC76, PC77
	.DW	PC78, PC79, PC7A, PC7B, PC7C, PC7D, PC7E, PC7F

; function's table for p-code tokens $80..$FF	
PCODET2:
	.DW	PC80, PC90, PCA0, PCB0, PCC0, PCD0, PCE0, PCF0

; function's in 'compile' mode	
CFUNCT:
	.DW	CF00, CF01, CF02, CF03, CF04, CF05, CF06, CF07, CF08
	
RFUNCT:
	.DW	RF00, RF01, RF02, RF03, RF04, RF05, RF06, RF07
	.DW	RF08, RF09, RF0A, RF0B, RF0C, RF0D, RF0E, RF0F
	.DW	RF10, RF11, RF12, RF13, RF14, RF15, RF16, RF17
	.DW	RF18, RF19, RF1A, RF1B, RF1C, RF1D, RF1E, RF1F
	.DW	RF20, RF21, RF22, RF23, RF24, RF25, RF26, RF27
	.DW	RF28, RF29, RF2A, RF2B, RF2C, RF2D, RF2E, RF2F
	.DW	RF30

; tmp. file name: delete
DTMPNAM:
	.DB	'S0:PCODEV01.XT?', $00

; temp. file name (copy in ram)
TTMPNAM:
	.DB	'0:PCODEV01.XTN', $00
	.DW	10, 100, 1000, 10000, 40000
	.DB	'true ', $00
	.DB	'false', $00
	.DB	$20, $00, $42, $00, $20, $00, $A0, $00, $20, $00, $A4, $00
TTMPSIZ	.EQU	($ - TTMPNAM)

STRFMT1:
	.DB	'disk error(#%bu): %s - file: "%s"', $00
STRFMT1A:
	.DB	'disk error(#%bu): %s', $00
STRFMT2:
	.DB	'runtime error(#%bu): %s', $00
STRFMT3:
	.DB	', line %hu', $00
STRFMT4:
	.DB	'bank: $%02bX, pcptr: $%04hX (current: $%04hX), opcode: $%02bX', $0D
	.DB	'stackptr:$%04hX, heapptr:$%04hX, fileptr: $%04hX', $00
	
; run-time error string's
TERRS:
	.DB	'stack overflow', 0		; 01
	.DB	'integer read error', 0		; 02
	.DB	'integer overflow', 0		; 03
	.DB	'array index error', 0		; 04
	.DB	'variable out of range', 0	; 05
	.DB	'case error', 0			; 06
	.DB	'bad p-code', 0			; 07
	.DB	'set value error', 0		; 08
	.DB	'floating point overflow', 0	; 09
	.DB	'floating point read error', 0	; 0A
	.DB	'undefined goto', 0		; 0B
	.DB	'complex log or square root', 0	; 0C
	.DB	'file not open for reading', 0	; 0D
	.DB	'file not open for writing', 0	; 0E
	.DB	'end of file', 0		; 0F
	.DB	'no free i/o channels', 0	; 10
	.DB	'device read error', 0		; 11
	.DB	'division by zero', 0		; 12
	.DB	'break', 0			; 13
	.DB	'missing drive number', 0	; 14
	.DB	'logical file not open', 0	; 15
	.DB	'logical file already open', 0	; 16
	.DB	'file not found', 0		; 17
	.DB	'device not present', 0		; 18
	.DB	'missing file name', 0		; 19
	.DB	'illegal device number', 0	; 1A	
	.DB	'should not occur', 0
	.DB	$00
