
; FONT.ASM
; PROGETTO: B1601
; Compilatore Avocet X65816

; set caratteri VDC 8563

.INCLUDE	inc\global.inc


;----------------------------------------------------------------------------
; SEGMENTO VDCFONT
;----------------------------------------------------------------------------

; Definizione set caratteri VDC -- start $0000, 4K
VDCFONT:	.SECTION
		
		.GLOBAL VGA8x8L, VGA8x8H

;; FONT VGA 8x8 LOW (00-7F)  FFF800 - F8FBFF 
VGA8x8L:
	.DB	$00, $00, $00, $00, $00, $00, $00, $00	; 0
	.DB	$7E, $81, $A5, $81, $BD, $99, $81, $7E	; 1
	.DB	$7E, $FF, $DB, $FF, $C3, $E7, $FF, $7E	; 2
	.DB	$6C, $FE, $FE, $FE, $7C, $38, $10, $00	; 3
	.DB	$10, $38, $7C, $FE, $7C, $38, $10, $00	; 4
	.DB	$38, $7C, $38, $FE, $FE, $D6, $10, $38	; 5
	.DB	$10, $38, $7C, $FE, $FE, $7C, $10, $38	; 6
	.DB	$00, $00, $18, $3C, $3C, $18, $00, $00	; 7
	.DB	$FF, $FF, $E7, $C3, $C3, $E7, $FF, $FF	; 8
	.DB	$00, $3C, $66, $42, $42, $66, $3C, $00	; 9
	.DB	$FF, $C3, $99, $BD, $BD, $99, $C3, $FF	; 10
	.DB	$0F, $07, $0F, $7D, $CC, $CC, $CC, $78	; 11
	.DB	$3C, $66, $66, $66, $3C, $18, $7E, $18	; 12
	.DB	$3F, $33, $3F, $30, $30, $70, $F0, $E0	; 13
	.DB	$7F, $63, $7F, $63, $63, $67, $E6, $C0	; 14
	.DB	$18, $DB, $3C, $E7, $E7, $3C, $DB, $18	; 15
	.DB	$80, $E0, $F8, $FE, $F8, $E0, $80, $00	; 16
	.DB	$02, $0E, $3E, $FE, $3E, $0E, $02, $00	; 17
	.DB	$18, $3C, $7E, $18, $18, $7E, $3C, $18	; 18
	.DB	$66, $66, $66, $66, $66, $00, $66, $00	; 19
	.DB	$7F, $DB, $DB, $7B, $1B, $1B, $1B, $00	; 20
	.DB	$3E, $61, $3C, $66, $66, $3C, $86, $7C	; 21
	.DB	$00, $00, $00, $00, $7E, $7E, $7E, $00	; 22
	.DB	$18, $3C, $7E, $18, $7E, $3C, $18, $FF	; 23
	.DB	$18, $3C, $7E, $18, $18, $18, $18, $00	; 24
	.DB	$18, $18, $18, $18, $7E, $3C, $18, $00	; 25
	.DB	$00, $18, $0C, $FE, $0C, $18, $00, $00	; 26
	.DB	$00, $30, $60, $FE, $60, $30, $00, $00	; 27
	.DB	$00, $00, $C0, $C0, $C0, $FE, $00, $00	; 28
	.DB	$00, $24, $66, $FF, $66, $24, $00, $00	; 29
	.DB	$00, $18, $3C, $7E, $FF, $FF, $00, $00	; 30
	.DB	$00, $FF, $FF, $7E, $3C, $18, $00, $00	; 31
	.DB	$00, $00, $00, $00, $00, $00, $00, $00	; ' '
	.DB	$18, $3C, $3C, $18, $18, $00, $18, $00	; '!'
	.DB	$66, $66, $24, $00, $00, $00, $00, $00	; '"'
	.DB	$6C, $6C, $FE, $6C, $FE, $6C, $6C, $00	; '#'
	.DB	$18, $3E, $60, $3C, $06, $7C, $18, $00	; '$'
	.DB	$00, $C6, $CC, $18, $30, $66, $C6, $00	; '%'
	.DB	$38, $6C, $38, $76, $DC, $CC, $76, $00	; '&'
	.DB	$18, $18, $30, $00, $00, $00, $00, $00	; '''
	.DB	$0C, $18, $30, $30, $30, $18, $0C, $00	; '('
	.DB	$30, $18, $0C, $0C, $0C, $18, $30, $00	; ')'
	.DB	$00, $66, $3C, $FF, $3C, $66, $00, $00	; '*'
	.DB	$00, $18, $18, $7E, $18, $18, $00, $00	; '+'
	.DB	$00, $00, $00, $00, $00, $18, $18, $30	; ','
	.DB	$00, $00, $00, $7E, $00, $00, $00, $00	; '-'
	.DB	$00, $00, $00, $00, $00, $18, $18, $00	; '.'
	.DB	$06, $0C, $18, $30, $60, $C0, $80, $00	; '/'
	.DB	$38, $6C, $C6, $D6, $C6, $6C, $38, $00	; '0'
	.DB	$18, $38, $18, $18, $18, $18, $7E, $00	; '1'
	.DB	$7C, $C6, $06, $1C, $30, $66, $FE, $00	; '2'
	.DB	$7C, $C6, $06, $3C, $06, $C6, $7C, $00	; '3'
	.DB	$1C, $3C, $6C, $CC, $FE, $0C, $1E, $00	; '4'
	.DB	$FE, $C0, $C0, $FC, $06, $C6, $7C, $00	; '5'
	.DB	$38, $60, $C0, $FC, $C6, $C6, $7C, $00	; '6'
	.DB	$FE, $C6, $0C, $18, $30, $30, $30, $00	; '7'
	.DB	$7C, $C6, $C6, $7C, $C6, $C6, $7C, $00	; '8'
	.DB	$7C, $C6, $C6, $7E, $06, $0C, $78, $00	; '9'
	.DB	$00, $18, $18, $00, $00, $18, $18, $00	; ':'
	.DB	$00, $18, $18, $00, $00, $18, $18, $30	; ';'
	.DB	$06, $0C, $18, $30, $18, $0C, $06, $00	; '<'
	.DB	$00, $00, $7E, $00, $00, $7E, $00, $00	; '='
	.DB	$60, $30, $18, $0C, $18, $30, $60, $00	; '>'
	.DB	$7C, $C6, $0C, $18, $18, $00, $18, $00	; '?'
	.DB	$7C, $C6, $DE, $DE, $DE, $C0, $78, $00	; '@'
	.DB	$38, $6C, $C6, $FE, $C6, $C6, $C6, $00	; 'A'
	.DB	$FC, $66, $66, $7C, $66, $66, $FC, $00	; 'B'
	.DB	$3C, $66, $C0, $C0, $C0, $66, $3C, $00	; 'C'
	.DB	$F8, $6C, $66, $66, $66, $6C, $F8, $00	; 'D'
	.DB	$FE, $62, $68, $78, $68, $62, $FE, $00	; 'E'
	.DB	$FE, $62, $68, $78, $68, $60, $F0, $00	; 'F'
	.DB	$3C, $66, $C0, $C0, $CE, $66, $3A, $00	; 'G'
	.DB	$C6, $C6, $C6, $FE, $C6, $C6, $C6, $00	; 'H'
	.DB	$3C, $18, $18, $18, $18, $18, $3C, $00	; 'I'
	.DB	$1E, $0C, $0C, $0C, $CC, $CC, $78, $00	; 'J'
	.DB	$E6, $66, $6C, $78, $6C, $66, $E6, $00	; 'K'
	.DB	$F0, $60, $60, $60, $62, $66, $FE, $00	; 'L'
	.DB	$C6, $EE, $FE, $FE, $D6, $C6, $C6, $00	; 'M'
	.DB	$C6, $E6, $F6, $DE, $CE, $C6, $C6, $00	; 'N'
	.DB	$7C, $C6, $C6, $C6, $C6, $C6, $7C, $00	; 'O'
	.DB	$FC, $66, $66, $7C, $60, $60, $F0, $00	; 'P'
	.DB	$7C, $C6, $C6, $C6, $C6, $CE, $7C, $0E	; 'Q'
	.DB	$FC, $66, $66, $7C, $6C, $66, $E6, $00	; 'R'
	.DB	$3C, $66, $30, $18, $0C, $66, $3C, $00	; 'S'
	.DB	$7E, $7E, $5A, $18, $18, $18, $3C, $00	; 'T'
	.DB	$C6, $C6, $C6, $C6, $C6, $C6, $7C, $00	; 'U'
	.DB	$C6, $C6, $C6, $C6, $C6, $6C, $38, $00	; 'V'
	.DB	$C6, $C6, $C6, $D6, $D6, $FE, $6C, $00	; 'W'
	.DB	$C6, $C6, $6C, $38, $6C, $C6, $C6, $00	; 'X'
	.DB	$66, $66, $66, $3C, $18, $18, $3C, $00	; 'Y'
	.DB	$FE, $C6, $8C, $18, $32, $66, $FE, $00	; 'Z'
	.DB	$3C, $30, $30, $30, $30, $30, $3C, $00	; '['
	.DB	$C0, $60, $30, $18, $0C, $06, $02, $00	; '\'
	.DB	$3C, $0C, $0C, $0C, $0C, $0C, $3C, $00	; ']'
	.DB	$10, $38, $6C, $C6, $00, $00, $00, $00	; '^'
	.DB	$00, $00, $00, $00, $00, $00, $00, $FF	; '_'
	.DB	$30, $18, $0C, $00, $00, $00, $00, $00	; '`'
	.DB	$00, $00, $78, $0C, $7C, $CC, $76, $00	; 'a'
	.DB	$E0, $60, $7C, $66, $66, $66, $DC, $00	; 'b'
	.DB	$00, $00, $7C, $C6, $C0, $C6, $7C, $00	; 'c'
	.DB	$1C, $0C, $7C, $CC, $CC, $CC, $76, $00	; 'd'
	.DB	$00, $00, $7C, $C6, $FE, $C0, $7C, $00	; 'e'
	.DB	$3C, $66, $60, $F8, $60, $60, $F0, $00	; 'f'
	.DB	$00, $00, $76, $CC, $CC, $7C, $0C, $F8	; 'g'
	.DB	$E0, $60, $6C, $76, $66, $66, $E6, $00	; 'h'
	.DB	$18, $00, $38, $18, $18, $18, $3C, $00	; 'i'
	.DB	$06, $00, $06, $06, $06, $66, $66, $3C	; 'j'
	.DB	$E0, $60, $66, $6C, $78, $6C, $E6, $00	; 'k'
	.DB	$38, $18, $18, $18, $18, $18, $3C, $00	; 'l'
	.DB	$00, $00, $EC, $FE, $D6, $D6, $D6, $00	; 'm'
	.DB	$00, $00, $DC, $66, $66, $66, $66, $00	; 'n'
	.DB	$00, $00, $7C, $C6, $C6, $C6, $7C, $00	; 'o'
	.DB	$00, $00, $DC, $66, $66, $7C, $60, $F0	; 'p'
	.DB	$00, $00, $76, $CC, $CC, $7C, $0C, $1E	; 'q'
	.DB	$00, $00, $DC, $76, $60, $60, $F0, $00	; 'r'
	.DB	$00, $00, $7E, $C0, $7C, $06, $FC, $00	; 's'
	.DB	$30, $30, $FC, $30, $30, $36, $1C, $00	; 't'
	.DB	$00, $00, $CC, $CC, $CC, $CC, $76, $00	; 'u'
	.DB	$00, $00, $C6, $C6, $C6, $6C, $38, $00	; 'v'
	.DB	$00, $00, $C6, $D6, $D6, $FE, $6C, $00	; 'w'
	.DB	$00, $00, $C6, $6C, $38, $6C, $C6, $00	; 'x'
	.DB	$00, $00, $C6, $C6, $C6, $7E, $06, $FC	; 'y'
	.DB	$00, $00, $7E, $4C, $18, $32, $7E, $00	; 'z'
	.DB	$0E, $18, $18, $70, $18, $18, $0E, $00	; '{'
	.DB	$18, $18, $18, $18, $18, $18, $18, $00	; '|'
	.DB	$70, $18, $18, $0E, $18, $18, $70, $00	; '}'
	.DB	$76, $DC, $00, $00, $00, $00, $00, $00	; '~'
	.DB	$00, $10, $38, $6C, $C6, $C6, $FE, $00	; ''

;; FONT VGA 8x8 HIGH (80-FF)  FFFC00 - FFFFFF 
VGA8x8H:
	.DB	$7C, $C6, $C0, $C0, $C6, $7C, $0C, $78	; 128
	.DB	$CC, $00, $CC, $CC, $CC, $CC, $76, $00	; 129
	.DB	$0C, $18, $7C, $C6, $FE, $C0, $7C, $00	; 130
	.DB	$7C, $82, $78, $0C, $7C, $CC, $76, $00	; 131
	.DB	$C6, $00, $78, $0C, $7C, $CC, $76, $00	; 132
	.DB	$30, $18, $78, $0C, $7C, $CC, $76, $00	; 133
	.DB	$30, $30, $78, $0C, $7C, $CC, $76, $00	; 134
	.DB	$00, $00, $7E, $C0, $C0, $7E, $0C, $38	; 135
	.DB	$7C, $82, $7C, $C6, $FE, $C0, $7C, $00	; 136
	.DB	$C6, $00, $7C, $C6, $FE, $C0, $7C, $00	; 137
	.DB	$30, $18, $7C, $C6, $FE, $C0, $7C, $00	; 138
	.DB	$66, $00, $38, $18, $18, $18, $3C, $00	; 139
	.DB	$7C, $82, $38, $18, $18, $18, $3C, $00	; 140
	.DB	$30, $18, $00, $38, $18, $18, $3C, $00	; 141
	.DB	$C6, $38, $6C, $C6, $FE, $C6, $C6, $00	; 142
	.DB	$38, $6C, $7C, $C6, $FE, $C6, $C6, $00	; 143
	.DB	$18, $30, $FE, $C0, $F8, $C0, $FE, $00	; 144
	.DB	$00, $00, $7E, $12, $FE, $90, $FE, $00	; 145
	.DB	$3E, $6C, $CC, $FE, $CC, $CC, $CE, $00	; 146
	.DB	$7C, $82, $7C, $C6, $C6, $C6, $7C, $00	; 147
	.DB	$C6, $00, $7C, $C6, $C6, $C6, $7C, $00	; 148
	.DB	$30, $18, $7C, $C6, $C6, $C6, $7C, $00	; 149
	.DB	$78, $84, $00, $CC, $CC, $CC, $76, $00	; 150
	.DB	$60, $30, $CC, $CC, $CC, $CC, $76, $00	; 151
	.DB	$C6, $00, $C6, $C6, $C6, $7E, $06, $FC	; 152
	.DB	$C6, $38, $6C, $C6, $C6, $6C, $38, $00	; 153
	.DB	$C6, $00, $C6, $C6, $C6, $C6, $7C, $00	; 154
	.DB	$00, $02, $7C, $CE, $D6, $E6, $7C, $80	; 155
	.DB	$38, $6C, $64, $F0, $60, $66, $FC, $00	; 156
	.DB	$3A, $6C, $CE, $D6, $E6, $6C, $B8, $00	; 157
	.DB	$00, $C6, $6C, $38, $6C, $C6, $00, $00	; 158
	.DB	$0E, $1B, $18, $3C, $18, $D8, $70, $00	; 159
	.DB	$18, $30, $78, $0C, $7C, $CC, $76, $00	; 160
	.DB	$0C, $18, $00, $38, $18, $18, $3C, $00	; 161
	.DB	$0C, $18, $7C, $C6, $C6, $C6, $7C, $00	; 162
	.DB	$18, $30, $CC, $CC, $CC, $CC, $76, $00	; 163
	.DB	$76, $DC, $00, $DC, $66, $66, $66, $00	; 164
	.DB	$76, $DC, $00, $E6, $F6, $DE, $CE, $00	; 165
	.DB	$3C, $6C, $6C, $3E, $00, $7E, $00, $00	; 166
	.DB	$38, $6C, $6C, $38, $00, $7C, $00, $00	; 167
	.DB	$18, $00, $18, $18, $30, $63, $3E, $00	; 168
	.DB	$7E, $81, $B9, $A5, $B9, $A5, $81, $7E	; 169
	.DB	$00, $00, $00, $FE, $06, $06, $00, $00	; 170
	.DB	$63, $E6, $6C, $7E, $33, $66, $CC, $0F	; 171
	.DB	$63, $E6, $6C, $7A, $36, $6A, $DF, $06	; 172
	.DB	$18, $00, $18, $18, $3C, $3C, $18, $00	; 173
	.DB	$00, $33, $66, $CC, $66, $33, $00, $00	; 174
	.DB	$00, $CC, $66, $33, $66, $CC, $00, $00	; 175
	.DB	$22, $88, $22, $88, $22, $88, $22, $88	; 176
	.DB	$55, $AA, $55, $AA, $55, $AA, $55, $AA	; 177
	.DB	$77, $DD, $77, $DD, $77, $DD, $77, $DD	; 178
	.DB	$18, $18, $18, $18, $18, $18, $18, $18	; 179
	.DB	$18, $18, $18, $18, $F8, $18, $18, $18	; 180
	.DB	$30, $60, $38, $6C, $C6, $FE, $C6, $00	; 181
	.DB	$7C, $82, $38, $6C, $C6, $FE, $C6, $00	; 182
	.DB	$18, $0C, $38, $6C, $C6, $FE, $C6, $00	; 183
	.DB	$7E, $81, $9D, $A1, $A1, $9D, $81, $7E	; 184
	.DB	$36, $36, $F6, $06, $F6, $36, $36, $36	; 185
	.DB	$36, $36, $36, $36, $36, $36, $36, $36	; 186
	.DB	$00, $00, $FE, $06, $F6, $36, $36, $36	; 187
	.DB	$36, $36, $F6, $06, $FE, $00, $00, $00	; 188
	.DB	$18, $18, $7E, $C0, $C0, $7E, $18, $18	; 189
	.DB	$66, $66, $3C, $7E, $18, $7E, $18, $18	; 190
	.DB	$00, $00, $00, $00, $F8, $18, $18, $18	; 191
	.DB	$18, $18, $18, $18, $1F, $00, $00, $00	; 192
	.DB	$18, $18, $18, $18, $FF, $00, $00, $00	; 193
	.DB	$00, $00, $00, $00, $FF, $18, $18, $18	; 194
	.DB	$18, $18, $18, $18, $1F, $18, $18, $18	; 195
	.DB	$00, $00, $00, $00, $FF, $00, $00, $00	; 196
	.DB	$18, $18, $18, $18, $FF, $18, $18, $18	; 197
	.DB	$76, $DC, $7C, $06, $7E, $C6, $7E, $00	; 198
	.DB	$76, $DC, $38, $6C, $C6, $FE, $C6, $00	; 199
	.DB	$36, $36, $37, $30, $3F, $00, $00, $00	; 200
	.DB	$00, $00, $3F, $30, $37, $36, $36, $36	; 201
	.DB	$36, $36, $F7, $00, $FF, $00, $00, $00	; 202
	.DB	$00, $00, $FF, $00, $F7, $36, $36, $36	; 203
	.DB	$36, $36, $37, $30, $37, $36, $36, $36	; 204
	.DB	$00, $00, $FF, $00, $FF, $00, $00, $00	; 205
	.DB	$36, $36, $F7, $00, $F7, $36, $36, $36	; 206
	.DB	$00, $C6, $7C, $C6, $C6, $7C, $C6, $00	; 207
	.DB	$30, $7E, $0C, $7C, $CC, $CC, $78, $00	; 208
	.DB	$F8, $6C, $66, $F6, $66, $6C, $F8, $00	; 209
	.DB	$7C, $82, $FE, $C0, $FC, $C0, $FE, $00	; 210
	.DB	$C6, $00, $FE, $C0, $FC, $C0, $FE, $00	; 211
	.DB	$30, $18, $FE, $C0, $FC, $C0, $FE, $00	; 212
	.DB	$00, $00, $38, $18, $18, $18, $3C, $00	; 213
	.DB	$0C, $18, $3C, $18, $18, $18, $3C, $00	; 214
	.DB	$3C, $42, $3C, $18, $18, $18, $3C, $00	; 215
	.DB	$66, $00, $3C, $18, $18, $18, $3C, $00	; 216
	.DB	$18, $18, $18, $18, $F8, $00, $00, $00	; 217
	.DB	$00, $00, $00, $00, $1F, $18, $18, $18	; 218
	.DB	$FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF	; 219
	.DB	$00, $00, $00, $00, $FF, $FF, $FF, $FF	; 220
	.DB	$18, $18, $18, $00, $00, $18, $18, $18	; 221
	.DB	$30, $18, $3C, $18, $18, $18, $3C, $00	; 222
	.DB	$FF, $FF, $FF, $FF, $00, $00, $00, $00	; 223
	.DB	$30, $60, $38, $6C, $C6, $6C, $38, $00	; 224
	.DB	$78, $CC, $CC, $D8, $CC, $C6, $CC, $00	; 225
	.DB	$7C, $82, $38, $6C, $C6, $6C, $38, $00	; 226
	.DB	$0C, $06, $38, $6C, $C6, $6C, $38, $00	; 227
	.DB	$76, $DC, $7C, $C6, $C6, $C6, $7C, $00	; 228
	.DB	$76, $DC, $38, $6C, $C6, $6C, $38, $00	; 229
	.DB	$00, $00, $66, $66, $66, $66, $7C, $C0	; 230
	.DB	$E0, $60, $7C, $66, $66, $7C, $60, $F0	; 231
	.DB	$F0, $60, $7C, $66, $7C, $60, $F0, $00	; 232
	.DB	$18, $30, $C6, $C6, $C6, $C6, $7C, $00	; 233
	.DB	$7C, $82, $00, $C6, $C6, $C6, $7C, $00	; 234
	.DB	$60, $30, $C6, $C6, $C6, $C6, $7C, $00	; 235
	.DB	$18, $30, $C6, $C6, $C6, $7E, $06, $FC	; 236
	.DB	$0C, $18, $66, $66, $3C, $18, $3C, $00	; 237
	.DB	$FF, $00, $00, $00, $00, $00, $00, $00	; 238
	.DB	$0C, $18, $30, $00, $00, $00, $00, $00	; 239
	.DB	$00, $00, $00, $7E, $00, $00, $00, $00	; 240
	.DB	$18, $18, $7E, $18, $18, $00, $7E, $00	; 241
	.DB	$00, $00, $00, $00, $00, $FF, $00, $FF	; 242
	.DB	$E1, $32, $E4, $3A, $F6, $2A, $5F, $86	; 243
	.DB	$7F, $DB, $DB, $7B, $1B, $1B, $1B, $00	; 244
	.DB	$3E, $61, $3C, $66, $66, $3C, $86, $7C	; 245
	.DB	$00, $18, $00, $7E, $00, $18, $00, $00	; 246
	.DB	$00, $00, $00, $00, $00, $18, $0C, $38	; 247
	.DB	$38, $6C, $6C, $38, $00, $00, $00, $00	; 248
	.DB	$00, $C6, $00, $00, $00, $00, $00, $00	; 249
	.DB	$00, $00, $00, $18, $00, $00, $00, $00	; 250
	.DB	$18, $38, $18, $18, $3C, $00, $00, $00	; 251
	.DB	$78, $0C, $38, $0C, $78, $00, $00, $00	; 252
	.DB	$78, $0C, $18, $30, $7C, $00, $00, $00	; 253
	.DB	$00, $00, $3C, $3C, $3C, $3C, $00, $00	; 254
	.DB	$00, $00, $00, $00, $00, $00, $00, $00	; 255

END_FONT	.EQU	$

		.ENDS
